#include "Tpostprocessor.h"
#include<QFile>
#include"tcad.h"
#include"mainwindow.h"

Tpostprocessor::Tpostprocessor()
{
    cut_swithed_on=0;
}

void Tpostprocessor::Generate()
{
   QFile f(TCAD::CAD->pconf->dir_output);
   if (f.open(QIODevice::WriteOnly ))
   {
    QTextStream writeStream(&f);
        writeStream << BeginProg();
        for(int i=0; i<TCAD::CAD->OrdersList.count(); i++ )
        {
//            int is3pt = TCAD::CAD->OrdersList[i]->orderinfo.blade_thickness=="3pt" ? 1:0;
            TPolylineContainer *pc = TCAD::CAD->OrdersList[i]->Layers;
            writeStream << "\n\n; "+TCAD::CAD->ListTool->OrdersTable.item(i,1)->text() + "  "+TCAD::CAD->ListTool->OrdersTable.item(i,2)->text() + "\n";
            writeStream << Route(pc);
        }
        writeStream << EndProg();

    f.close();

    TCAD::MainWin->SetStatusMessage("Записано!!");
   }
   else
     TCAD::MainWin->SetStatusMessage("Ошибка записи в файл "+TCAD::CAD->pconf->dir_output);
}


QString Tpostprocessor::BeginProg()
{
    QString S = TCAD::CAD->pconf->first_text+"\n"; // QString(";Начало!!\n G92 X0 Y0 \nG90\nF1000\n");
    return S;
}

QString Tpostprocessor::EndProg()
{
    QString S = TCAD::CAD->pconf->prog_end+"\n";//  QString("\nM30\n");
    return S;
}

QString Tpostprocessor::ToolDown()
{
    if(cut_swithed_on) return "";
    cut_swithed_on=1;
    QString S = TCAD::CAD->pconf->tool_engage+"\n";
    return S;
}

QString Tpostprocessor::ToolUp()
{
    cut_swithed_on=0;
    QString S = TCAD::CAD->pconf->tool_off+"\n";
    return S;
}

QString Tpostprocessor::Route(TPolylineContainer *_pc)
{
    QString s;
    QString lasttool= "";
    int acc=3;
    int dec=0;
    TPolylineContainer *pc = _pc;
    TCAD::CAD->MatrixShiftX0=0;
    TCAD::CAD->MatrixShiftY0=0;
    double bx1, bx2, by1, by2;
    double b1x1, b1x2, b1y1, b1y2;

    QString CurrF;

    while(pc)
    {
     dec=0;
     if(pc->visible)
     {
         TPolyline *p = pc->Polylines;

         int col = pc->layer.toInt();

         if(col==0)
         {
             s+= TCAD::CAD->pconf->tcut[0];
             CurrF = TCAD::CAD->pconf->tcutF[0];
         }
         else
             if(col<10)
             {
                 lasttool = TCAD::CAD->pconf->ttext[TCAD::CAD->curr_board_thick];
                 s+= lasttool;
                 CurrF = TCAD::CAD->pconf->ttextF[TCAD::CAD->curr_board_thick];
             }
             else
                 if( col < 80 )
                 {
                     dec = col - 10*(col/10);
                     if(dec==1)
                     {
                         lasttool = TCAD::CAD->pconf->t1[TCAD::CAD->curr_board_thick];
                         s+= lasttool;
                         CurrF = TCAD::CAD->pconf->t1F[TCAD::CAD->curr_board_thick];
                     }
                     if(dec==2)
                     {
                         lasttool = TCAD::CAD->pconf->t2[TCAD::CAD->curr_board_thick];
                         s+= lasttool;
                         CurrF = TCAD::CAD->pconf->t2F[TCAD::CAD->curr_board_thick];
                     }
                     if(dec==3)
                     {
                         lasttool = TCAD::CAD->pconf->t3[TCAD::CAD->curr_board_thick];
                         s+= lasttool;
                         CurrF = TCAD::CAD->pconf->t3F[TCAD::CAD->curr_board_thick];
                     }
                     if(dec==4)
                     {
                         lasttool = TCAD::CAD->pconf->t4[TCAD::CAD->curr_board_thick];
                         s+= lasttool;
                         CurrF = TCAD::CAD->pconf->t4F[TCAD::CAD->curr_board_thick];
                     }
                     if(dec>4)
                     {
                         lasttool = TCAD::CAD->pconf->tcut[TCAD::CAD->curr_board_thick];
                         s+= lasttool;
                         CurrF = TCAD::CAD->pconf->tcutF[TCAD::CAD->curr_board_thick];
                     }
                 }
                 else
                 {
                     switch (col) {
                     case 200:
                         lasttool = TCAD::CAD->pconf->t2[TCAD::CAD->curr_board_thick];
                         s+= lasttool;
                         CurrF = TCAD::CAD->pconf->t2F[TCAD::CAD->curr_board_thick];
                         break;
                     case 201:
                         lasttool = TCAD::CAD->pconf->t3[TCAD::CAD->curr_board_thick];
                         s+= lasttool;
                         CurrF = TCAD::CAD->pconf->t3F[TCAD::CAD->curr_board_thick];
                         break;
                     case 80:
                     case 90:
                     case 253:
                         lasttool = TCAD::CAD->pconf->tcut[TCAD::CAD->curr_board_thick];
                         s+= lasttool;
                         CurrF = TCAD::CAD->pconf->tcutF[TCAD::CAD->curr_board_thick];
                         break;
                     default:
                         lasttool = TCAD::CAD->pconf->tcut[TCAD::CAD->curr_board_thick];
                         s+= lasttool;
                         CurrF = TCAD::CAD->pconf->tcutF[TCAD::CAD->curr_board_thick];
                         break;
                     }
                 }

         s+="\n";

         while(p)
         {
            int is_bridge_arfer=0;
            int is_bridge_before=0;
            if( (dec==3) && (TCAD::CAD->pconf->use_3pt_briges) )
            {
                 TPolyline *p1 = pc->Polylines;
                 while(p1)
                 {
                     double bridge_len = LineLen( p->lastV()->x, p->lastV()->y, p1->firstV->x, p1->firstV->y  );
                     if( (bridge_len < 6.6) and (bridge_len>2.9) )
                     {
                         double a1 = p->VectorAngle(1);
                         double a2 = VectorToRadial(p->lastV()->x, p->lastV()->y, p1->firstV->x, p1->firstV->y);
                         double da = qAbs(a1-a2);
                         if( da < 0.1 )
                         {
                             bx1=p->lastV()->x; by1=p->lastV()->y;
                             bx2=p1->firstV->x; by2=p1->firstV->y;
                             is_bridge_arfer=1;
                         }
                     }

                     bridge_len = LineLen( p->firstV->x, p->firstV->y, p1->firstV->x, p1->firstV->y  );
                     if( (bridge_len < 6.6) and (bridge_len>2.9) )
                     {
                         double a1 = p->VectorAngle(0);
                         double a2 = VectorToRadial(p1->firstV->x, p1->firstV->y, p->firstV->x, p->firstV->y);
                         double da = qAbs(a1-a2);
                         if( da < 0.1 )
                         {
                             b1x1=p->firstV->x; b1y1=p->firstV->y;
                             b1x2=p1->firstV->x; b1y2=p1->firstV->y;
                             is_bridge_before=1;
                         }
                     }
                     p1=p1->next;
                 }
            }


            if( p->type==0 )
            {
                 TVertex *v = p->firstV;
                 TVertex tmpv;
                 if(cut_swithed_on==0)
                 {
                   s+= "G0 X"+QString::number(v->Xmatrix(v->x),0,acc)+" Y"+QString::number(v->Ymatrix(v->y),0,acc)+"\n";
                   s+= ToolDown();
                 }
                 v=v->next;
                 while(v)
                 {
                     long double Gi,Gj;

                     tmpv = *v;
                     Gi = v->prev->x0 - v->prev->x;
                     Gj = v->prev->y0 - v->prev->y;
                     if(v->prev->bulge>0)
                     {
                         s+= "G3 X"+QString::number(TVertex::Xmatrix(v->x),0,acc)+" Y"+QString::number(TVertex::Ymatrix(v->y),0,acc)+ " I"+QString::number(Gi,0,acc) + " J"+QString::number(Gj,0,acc) + " F"+CurrF+"\n";
                     } else
                         if(v->prev->bulge<0)
                         {
                             s+= "G2 X"+QString::number(TVertex::Xmatrix(v->x),0,acc)+" Y"+QString::number(TVertex::Ymatrix(v->y),0,acc)+ " I"+QString::number(Gi,0,acc) +  " J"+QString::number(Gj,0,acc) +" F"+CurrF+"\n";
                         } else
                         {
                             int FSpeed = CurrF.toFloat();
                             float len = LineLen(v->prev->x, v->prev->y, v->x, v->y);
                             float df = TCAD::CAD->pconf->MLS;
                             if(len< df)
                             {
                                 FSpeed *= (1 + ((float)TCAD::CAD->pconf->MLSinc)/100);
                             }
                             s+= "G1 X"+QString::number(TVertex::Xmatrix(v->x),0,acc)+" Y"+QString::number(TVertex::Ymatrix(v->y),0,acc)+" F"+ QString::number(FSpeed,4,0)+"\n";
                         }

                     v=v->next;
                 }

                 if(TCAD::CAD->pconf->use_3pt_briges )
                 {
                     if(is_bridge_arfer)
                     {
    //                     if((bx1==tmpv.x) && (by1==tmpv.y))
                         {
                             int FSpeed = TCAD::CAD->pconf->t3bridgesF.toFloat();
                             s+= TCAD::CAD->pconf->t3bridges+"; bridge\n";
                             s+= "G1 X"+QString::number(TVertex::Xmatrix(bx2),0,acc)+" Y"+QString::number(TVertex::Ymatrix(by2),0,acc)+" F"+ QString::number(FSpeed,4,0)+"\n";
                             s+= lasttool+"\n";
                             s+= ToolUp();
                         }
                     }
                     else
                     s+= ToolUp();
                 } else
                 s+= ToolUp();
             }

             p=p->next;
         }
     }
     pc=pc->next;
    }

    return s;

}
