#include "dbopenform.h"
#include<QDebug>

DbOpenForm::DbOpenForm(QWidget *parent) : QDialog(parent)
{
    QVBoxLayout *MainLayout = new QVBoxLayout();
    setLayout(MainLayout);
    QHBoxLayout *findlay = new QHBoxLayout();
    QHBoxLayout *pwlay = new QHBoxLayout();
    QHBoxLayout *Layout = new QHBoxLayout();
    QHBoxLayout *BtnLay = new QHBoxLayout();

    authfile = new QFile("auth.txt");

    MainLayout->addLayout(findlay);
    MainLayout->addLayout(Layout);
    MainLayout->addLayout(BtnLay);
    BtnLay->addLayout(pwlay);
    BtnLay->addStretch();

    find_edit = new TFindEdit(this);
    find_edit->setMaximumWidth(120);
    find_edit->setMinimumWidth(100);

    findlay->addWidget( new QLabel("Поиск по номеру (вводите не менее 4 цифр) "));
    findlay->addWidget(find_edit);
    findlay->addStretch();
    connect(find_edit,SIGNAL( textEdited(const QString&) ),this,SLOT(FindOrder(const QString&)) );

    pwlay->addWidget( new QLabel("Пользователь"));
    user_edit = new QLineEdit();
    user_edit->setMaximumWidth(100);
    pwlay->addWidget(user_edit);
    pwlay->addWidget( new QLabel("Пароль"));
    pass_edit = new QLineEdit();
    pass_edit->setMaximumWidth(70);
    pass_edit->setEchoMode(QLineEdit::Password);
    pwlay->addWidget(pass_edit);
    QPushButton *usrBtn = new QPushButton("Логин");
    pwlay->addWidget(usrBtn);
    pwlay->addStretch();
    connect(usrBtn,SIGNAL(clicked(bool)),this,SLOT(loginEvent()) );

    MainLayout->addSpacing(10);

    QPushButton *OkBtn = new QPushButton("Открыть",this);
    QPushButton *CancelBtn = new QPushButton("Отмена",this);
    BtnLay->addSpacing(500);
    BtnLay->addWidget(OkBtn);
    BtnLay->addWidget(CancelBtn);

    QVBoxLayout *left_side = new QVBoxLayout();
    Layout->addLayout(left_side);
    LWLeft = new LeftTable;

    left_side->addWidget(LWLeft);
    LWLeft->setMaximumWidth(140);
    LWLeft->setMinimumWidth(140);
    LWRight = new RightTable;
    LWRight->setMinimumWidth(800);
    LWRight->setMinimumHeight(650);
    LWLeft->setslave(LWRight);
    Layout->addWidget(LWRight);

    LWLeft->setStyleSheet("QTableView:item:selected {background-color: #4444aa; color: #FFFFFF}\n"
                                 "QTableView:item:selected:focus {background-color: #4444aa;}");

    QVBoxLayout *right_side = new QVBoxLayout();
    Layout->addLayout(right_side);
    GV = new QLabel();
    FTable = new FilesTable;
//    FTable->setSelectionMode(QAbstractItemView::SingleSelection);
//    FTable->setSelectionBehavior(QAbstractItemView::SelectRows);
    right_side->addWidget(FTable);
    right_side->addWidget(GV);

    find_edit->RT = LWRight;
    find_edit->dbof = this;

//    connect(FTable, SIGNAL(cellDoubleClicked(int,int)), this, SLOT( LoadSavedProj())  );

    connect(OkBtn,SIGNAL(clicked(bool)),this,SLOT(PushOk()) );
    connect(CancelBtn,SIGNAL(clicked(bool)),this,SLOT(PushCancel()) );

    LWLeftModel = new LeftModel;
    LWLeft->setModel(LWLeftModel);

    LWLeft->setSelectionMode(QAbstractItemView::SingleSelection);
    LWLeft->setSelectionBehavior(QAbstractItemView::SelectRows);
    LWLeft->setColumnWidth(0,180);
    LWLeft->selectRow(0);

    LWRight->setSelectionMode(QAbstractItemView::SingleSelection);
    LWRight->setSelectionBehavior(QAbstractItemView::SelectRows);
    connect(LWRight, SIGNAL(cellDoubleClicked(int,int)), this, SLOT( PushOk())  );

    LWRight->setContextMenuPolicy(Qt::CustomContextMenu);
    connect(LWRight, SIGNAL(customContextMenuRequested(QPoint)),this, SLOT(customMenuRequested(QPoint)));

    connect(LWRight,SIGNAL(currentCellChanged( int , int, int , int )), this, SLOT(RightRowChanged( int , int, int , int )) );
    nam = new QNetworkAccessManager(this);
    connect(nam, SIGNAL(finished(QNetworkReply*)), this, SLOT(ReceiveJpg(QNetworkReply*)));

    LWRight->setStyleSheet("QTableView:item:selected {background-color: #4444aa; color: #FFFFFF}\n"
                                 "QTableView:item:selected:focus {background-color: #4444aa;}");
}

void DbOpenForm::customMenuRequested(QPoint pos)
{
      QMenu *menu=new QMenu(this);
      QAction *qa1 = menu->addAction(tr("мцуйцум"), this, SLOT(actionMenu_ToGlue() ));
      QAction *qa2 = menu->addAction(tr("иекик"), this, SLOT(actionMenu_ToFinish() ));
      qa1->setEnabled((LWLeft->GetIndex()==0));
      qa2->setEnabled((LWLeft->GetIndex()==0) || (LWLeft->GetIndex()==1));

      menu->popup(LWRight->viewport()->mapToGlobal(pos));
}

void DbOpenForm::ShowForm()
{
//    QSqlQuery query;
    int cntr;

    authfile->open(QIODevice::ReadOnly);
    LWRight->username = authfile->readLine().trimmed();
    LWRight->password = authfile->readLine().trimmed();
    authfile->close();
    user_edit->setText(LWRight->username);
    pass_edit->setText(LWRight->password);

    find_edit->clear();
    LWRight->Rfindtext="";
    LWLeft->setVisible(true);
    show();
    LWLeft->selectRow(4);
    LWLeft->refreshTable();
}

void DbOpenForm::ReceiveHTTP(QNetworkReply *rep)
{
    QString string;
    emit StopWait();
        if (rep->error() == QNetworkReply::NoError)
        {
         QByteArray bytes = rep->readAll();
         string=QString(bytes);
         received = string;
        }
        else
        {
         qDebug() << rep->errorString();
        }
}

void DbOpenForm::PushOk()
{
//    TCAD::CAD->SaveProjToMysql();

    QUrl url;
//    QSqlQuery query;
//    query.exec("update config  set strval='"+ QString::number(LWLeft->GetIndex()) +"' where param='dbopenform_LWleft_row'");

    url = QUrl( QString( TCAD::main_url+"/work/files.php?idz=%1").arg( LWRight->selectedId() ) );
    disconnect(LWRight->nam,0,0,0);
    connect(LWRight->nam, SIGNAL(finished(QNetworkReply*)), this, SLOT(CheckExistsDXF(QNetworkReply*)));
    is_exists_dxf=0;
    LWRight->nam->get(QNetworkRequest(url));
    WaitDownload();

  if(is_exists_dxf)
   {
    url = QUrl( QString( TCAD::main_url+"/work/file_for.php?idz=%1").arg( LWRight->selectedId() ) );
    disconnect(LWRight->nam,0,0,0);
    connect(LWRight->nam, SIGNAL(finished(QNetworkReply*)), this, SLOT(downloadFinished(QNetworkReply*)));
    LWRight->nam->get(QNetworkRequest(url));
    WaitDownload();
    close();
    TCAD::CAD->OpenDXF("open.dxf", TOrders(QString::number(LWRight->selectedId()), LWRight->item(LWRight->currentRow(),1)->text(),
         LWRight->item(LWRight->currentRow(),5)->text(), LWRight->item(LWRight->currentRow(),9)->text(), LWRight->item(LWRight->currentRow(),7)->text(),LWRight->item(LWRight->currentRow(),8)->text() ) );

    url = QUrl( QString( TCAD::main_url+"/work/get_field.php?z_param&idz=%1").arg(LWRight->selectedId())  );
    disconnect(LWRight->nam,0,0,0);
    connect(LWRight->nam, SIGNAL(finished(QNetworkReply*)), this, SLOT(ReceiveHTTP(QNetworkReply*)));
    LWRight->nam->get(QNetworkRequest(url));
    WaitDownload();
    QStringList SubStr = received.split("%");
    if( SubStr.count()<2) return;

   } else
   {
      close();
      QMessageBox* pmbx = new QMessageBox("Пусто","В заказе отсутствуют файлы *.dxf",
                          QMessageBox::Information, QMessageBox::Ok, QMessageBox::NoButton,
                          QMessageBox::NoButton | QMessageBox::Escape);
      pmbx->exec();
      delete pmbx;
   }
}

void DbOpenForm::PushCancel()
{
    close();
}

void DbOpenForm::CheckExistsDXF(QNetworkReply *reply)
{
    QString string;
    emit StopWait();
        if (reply->error() == QNetworkReply::NoError)
        {
         QByteArray bytes = reply->readAll();
         string=QString(bytes);
         is_exists_dxf = (string=="dxf") ? 1:0;
        }
        else
        {
         qDebug() << reply->errorString();
        }
}

void DbOpenForm::downloadFinished(QNetworkReply *data)
{
    QString tmp =  data->rawHeader("content-disposition");
    QStringList ff = tmp.split("filename=");
    if(ff.count()==0) {
        filename_dowloaded = "none";
        return;
    }
    filename_dowloaded = ff[1];

    emit StopWait();
    QFile localFile("open.dxf");
    if (!localFile.open(QIODevice::WriteOnly))
            return;
    localFile.write(data->readAll());
    localFile.close();
}

void DbOpenForm::WaitDownload()
{
    QEventLoop eventLoop;
    connect(this, SIGNAL(StopWait()), &eventLoop, SLOT(quit()));

       QTimer timer ;//= new QTimer(this);
       connect(&timer, SIGNAL(timeout()), &eventLoop, SLOT(quit()));
       timer.setSingleShot(true);
       timer.start(5000);
       eventLoop.exec();
}

void DbOpenForm::loginEvent()
{
    LWRight->username = user_edit->text();
    LWRight->password = pass_edit->text();
    LWLeft->refreshTable();

    authfile->open(QIODevice::WriteOnly);
    QString str = LWRight->username+"\n";   authfile->write( str.toUtf8() );
    str = LWRight->password+"\n";   authfile->write( str.toUtf8() );
    authfile->close();

//    QSqlQuery query;
//    query.exec("update config  set strval='"+ user_edit->text() +"' where param='user_nskdb'");
//    query.exec("update config  set strval='"+ pass_edit->text() +"' where param='pass_nskdb'");
}

void DbOpenForm::actionMenu_ToGlue()
{
    QString s = TCAD::main_url+"/work/requests.php?ToSendOrderTo1=0&id="+QString::number( LWRight->selectedId() )+"&login="+LWRight->username;
    QUrl url( s );
    disconnect(LWRight->nam,0,0,0);
    connect(LWRight->nam, SIGNAL(finished(QNetworkReply*)), this, SLOT(ActionMenuNamEvent(QNetworkReply*)));
    LWRight->nam->get(QNetworkRequest(url));
    WaitDownload();
}
void DbOpenForm::actionMenu_ToFinish()
{
    QUrl url( QString( TCAD::main_url+"/work/requests.php?ToSendOrderTo2=0&id="+QString::number( LWRight->selectedId() )+"&login="+LWRight->username ) );
    disconnect(LWRight->nam,0,0,0);
    LWRight->nam->get(QNetworkRequest(url));
    connect(LWRight->nam, SIGNAL(finished(QNetworkReply*)), this, SLOT(ActionMenuNamEvent(QNetworkReply*)));
    WaitDownload();
}
void DbOpenForm::ActionMenuNamEvent(QNetworkReply *reply)
{
    QString string;
    emit StopWait();
        if (reply->error() == QNetworkReply::NoError)
        {
         QByteArray bytes = reply->readAll();
         string=QString(bytes);
//         qDebug()<<string;
         LWLeft->refreshTable();
        }
        else
        {
         qDebug() << reply->errorString();
        }
}

void DbOpenForm::RightRowChanged(int currentRow, int  , int, int)
{
    if( ! LWRight->scroll_enable ) return;

//    qDebug()<< "changed row; " << LWRight->model()->index(currentRow,0).data().toLongLong();
    long rez = LWRight->model()->index(currentRow,0).data().toLongLong();
    if(!rez) return;
    QUrl url( QString( TCAD::main_url+"/innerdxf/view.php?idz="+QString::number(rez)+"&W=250&H=250" )  );
    nam->get(QNetworkRequest(url));
//    FTable->fill_table(rez);
}

void DbOpenForm::ReceiveJpg(QNetworkReply* replyJpg)
{
    if (replyJpg->error() == QNetworkReply::NoError)
    {
     QByteArray bytes = replyJpg->readAll();
     QPixmap pm;
     pm.loadFromData(bytes);
     GV->setPixmap(pm);
    }
    else
    {
     qDebug() << replyJpg->errorString();
    }
}


void DbOpenForm::FindOrder(const QString &ftext)
{
   if(ftext.length()>3)
    {
        LWRight->Rfindtext=ftext;
        LWLeft->setVisible(false);
    }
   else
    LWRight->Rfindtext="xxx";

   if(ftext.length()==0)
   {    LWRight->Rfindtext="";
        LWLeft->setVisible(true);
   }
   LWLeft->refreshTable();
}



int LeftModel::rowCount(const QModelIndex &) const
{
     return 5;
}

int LeftModel::columnCount(const QModelIndex &) const
{
    return 1;
}

QVariant LeftModel::data(const QModelIndex &index, int role) const
{
    if (role == Qt::DisplayRole)
    {
     QString s[5] = {"Статус0","Статус1","Готовые","В проектировании","В резке"};
     if (role == Qt::DisplayRole)
     {
       return s[index.row()];
     }
     return 5;
    }
    else
            return QVariant();
}

QVariant LeftModel::headerData(int , Qt::Orientation orientation, int role ) const
{
   if (role == Qt::DisplayRole)
   {
     if(orientation==Qt::Horizontal)

       return "sectionfewf";
   }
   return "";
}

void LeftTable::setslave(RightTable* _slave)
{
    slave = _slave;
}

void LeftTable::refreshTable()
{
   QModelIndexList m =this->selectedIndexes();
   if(m.count()>0) slave->fill_table( (m.takeFirst()).row() );
}

int LeftTable::GetIndex()
{
    QModelIndexList m =selectedIndexes();
    if(m.count()>0)
     return (m.takeFirst()).row() ;
    return 0;
}

void LeftTable::selectionChanged(const QItemSelection & selected, const QItemSelection & )
{
  QModelIndexList m =selected.indexes();
  if(m.count()>0)
   slave->fill_table( (m.takeFirst()).row() );
}

RightTable::RightTable()
{
    nam = new QNetworkAccessManager(this);
    verticalHeader()->hide();
    setEditTriggers(QAbstractItemView::NoEditTriggers);
    username="";
    Rfindtext="";
    scroll_enable=0;
}

qlonglong RightTable::selectedId()
{
    QModelIndexList m = selectedIndexes();
    int row = m.takeFirst().row();
    return model()->index(row,0).data().toLongLong();
}

void RightTable::fill_table(int state)
{
 int set[]={5,6,10,1,4};
 int i;

 scroll_enable=0;
 int n = rowCount();
 for( i = 0; i < n; i++ ) removeRow( 0 );

 disconnect(nam,0,0,0);
 connect(nam, SIGNAL(finished(QNetworkReply*)), this, SLOT(ReceiveAutorize(QNetworkReply*)) );

 if(username=="") return;

 QUrl url( QString( TCAD::main_url+"/work/requests.php?login="+username+"&password="+password )  );
 nam->get(QNetworkRequest(url));
 WaitAutorize();

 disconnect(nam,0,0,0);
 connect(nam, SIGNAL(finished(QNetworkReply*)), this, SLOT(ReceiveHTTP(QNetworkReply*)));

 if(Rfindtext=="")
    url = QUrl( QString( TCAD::main_url+"/work/rq.php?1_list&state=%1").arg(set[state])  );
 else
    url = QUrl( QString( TCAD::main_url+"/work/rq.php?1_findorder="+Rfindtext)  );
// qDebug()<<url;
 nam->get(QNetworkRequest(url));
 scroll_enable=1;
}

void RightTable::WaitAutorize()
{
       QEventLoop eventLoop;
       QObject::connect(this, SIGNAL(AutorizeFinished()), &eventLoop, SLOT(quit()));

       QTimer timer;
       QObject::connect(&timer, SIGNAL(timeout()), &eventLoop, SLOT(quit()));
       timer.setSingleShot(true);
       timer.start(2000);

       eventLoop.exec();
}

void RightTable::ReceiveAutorize(QNetworkReply * replyAutorize)
{
    QString string;
    emit AutorizeFinished();
        if (replyAutorize->error() == QNetworkReply::NoError)
        {
         QByteArray bytes = replyAutorize->readAll();
         string=QString(bytes);
        }
        else
        {
         qDebug() << replyAutorize->errorString();
        }
}

void RightTable::ReceiveHTTP(QNetworkReply* reply)
{
QString string;
 scroll_enable=0;

    if (reply->error() == QNetworkReply::NoError)
    {
     QByteArray bytes = reply->readAll();
     string=QString(bytes);
     //qDebug() << string;`
    }
    else
    {
     qDebug() << reply->errorString();
    }

    QStringList Str = string.split(char(18) );
    if(Str.count()<2) return;

    int i,j, r=0;
    QString s;
    for( i=0; i<Str.count(); i++)
    {
     QString row = Str.at(i);
     QStringList SubStr = row.split("<~!%");
     if(row.count())
     {
      if(row.at(0)==char(12))
      {
       setColumnCount( SubStr.count()-1 );
       for(j=0; j<SubStr.count(); j++)
       {
           s = SubStr.at(j);
           s.replace("%","");
           int cwidth = s.toInt();
           if(cwidth==0)
            {
               setColumnHidden(j,true);
            } else
            {
               cwidth = cwidth * this->width()/90+20;
               setColumnWidth(j, cwidth );
            }
       }
      }
      else
      if(row.at(0)==char(11))
      {
        setHorizontalHeaderLabels(SubStr);
      }
      else
      {
       insertRow(r);
       setRowHeight(r, 20);
       //setVerticalHeaderLabels(Item(r,0);

       for(j=0; j<SubStr.count(); j++)
       {

        s = SubStr.at(j);
        setItem(r,j, new QTableWidgetItem(s));
       }
       r++;
      }
     }
    }

  scroll_enable=1;
  selectRow(0);
}

FilesTable::FilesTable()
{
    nam = new QNetworkAccessManager(this);
    verticalHeader()->hide();
    setEditTriggers(QAbstractItemView::NoEditTriggers);
}

void FilesTable::fill_table(int idz)
{
     int i;
     int n = rowCount();
     for( i = 0; i < n; i++ ) removeRow( 0 );

     disconnect(nam,0,0,0);
     connect(nam, SIGNAL(finished(QNetworkReply*)), this, SLOT(ReceiveHTTP(QNetworkReply*)));

     QUrl url = QUrl( QString( TCAD::main_url+"/work/get_drw_data.php?get_drw_list&idz=%1").arg(idz)  );
     nam->get(QNetworkRequest(url));
}

qlonglong FilesTable::selectedId()
{
    QModelIndexList m = selectedIndexes();
    int row = m.takeFirst().row();
    return model()->index(row,0).data().toLongLong();
}

void FilesTable::ReceiveHTTP(QNetworkReply* reply)
{
QString string;
    setColumnCount( 4 );
    setColumnHidden(0,true);
    setColumnWidth( 1, 95 );
    setColumnWidth( 2, 50 );
    setColumnWidth( 3, 120 );
    QStringList headers = QStringList()<<""<<"Дата"<< "Кбайт" <<"Файл";
    setHorizontalHeaderLabels(headers);

    if (reply->error() == QNetworkReply::NoError)
    {
     QByteArray bytes = reply->readAll();
     string=QString(bytes);
//     qDebug() << string;
    }
    else
    {
     qDebug() << reply->errorString();
    }

    QStringList Str = string.split( "<br>" );
    int i,j, r=0;
    QString s;
    for( i=0; i<Str.count(); i++)
    {
     QString row = Str.at(i);
     QStringList SubStr = row.split(";%,");

     if(row.count())
     {
      {
       insertRow(r);
       setRowHeight(r, 20);
       for(j=0; j<SubStr.count(); j++)
       {
        s = SubStr.at(j);
        setItem(r,j, new QTableWidgetItem(s));
       }
       r++;
      }
     }
    }
    selectRow(0);
}


void TFindEdit::keyPressEvent(QKeyEvent *event)
{
    if( event->key()== Qt::Key_Down )
     RT->setCurrentCell( RT->currentRow()+1 ,0);
    else
    if( event->key()== Qt::Key_Up )
     RT->setCurrentCell( RT->currentRow()-1 ,0);
    else
    if( (event->key()==Qt::Key_Enter) || (event->key()==Qt::Key_Return) )
        dbof->PushOk();
    else
        QLineEdit::keyPressEvent(event);
}

