#ifndef DBOPENFORM_H
#define DBOPENFORM_H

#include <qdialog.h>
#include<QVBoxLayout>
#include<QHBoxLayout>
#include<QPushButton>
#include<QTableWidget>
#include<QAbstractTableModel>
#include <QNetworkAccessManager>
#include <QUrl>
#include<QNetworkRequest>
#include<QNetworkReply>
#include<QEventLoop>
#include<QTimer>
#include<QHeaderView>
#include<QFile>
#include<QMessageBox>
#include<QLineEdit>
#include<QGraphicsView>
#include"tcad.h"
//#include <QSqlDatabase>
//#include<QSqlQuery>


class RightTable;
class DbOpenForm;

class TFindEdit : public QLineEdit
{
public:
    TFindEdit(QWidget *parent=0) : QLineEdit(parent)
    {};
    RightTable *RT;
    DbOpenForm *dbof;
protected:
    virtual void keyPressEvent(QKeyEvent *event);
};


class LeftModel : public QAbstractTableModel
{
private:
    int rowCount(const QModelIndex &parent) const;
    int columnCount(const QModelIndex &parent) const;
    QVariant data(const QModelIndex &index, int role) const;
    QVariant headerData(int section, Qt::Orientation orientation, int role = Qt::DisplayRole) const;
public:
};


class LeftTable : public QTableView
{
private:
    RightTable *slave;
    void selectionChanged(const QItemSelection & selected, const QItemSelection & deselected);
public:
    void setslave(RightTable* slave);
    void refreshTable();
    int GetIndex();
};

class RightTable : public QTableWidget
{
    Q_OBJECT
private:
public:
    QNetworkAccessManager *nam;
    RightTable();
    void fill_table(int state);
    void WaitAutorize();
    qlonglong selectedId();
    int scroll_enable;

    QString username;
    QString password;
    QString Rfindtext;

public slots:
    void ReceiveHTTP(QNetworkReply *);
    void ReceiveAutorize(QNetworkReply *);

signals:
    void AutorizeFinished();
    void ArrowPressed(int key);
};

class FilesTable : public QTableWidget
{
    Q_OBJECT
private:
public:
    QNetworkAccessManager *nam;
    FilesTable();
    void fill_table(int idz);
    qlonglong selectedId();

public slots:
    void ReceiveHTTP(QNetworkReply *);
};


class DbOpenForm : public QDialog
{
    Q_OBJECT

private:
    LeftTable *LWLeft;
    RightTable *LWRight;
    FilesTable *FTable;
    LeftModel* LWLeftModel ;
    QString user_nskdb;
    QString pass_nskdb;
    QFile *authfile;

    QLabel * GV;
    QNetworkAccessManager *nam;
    QString filename_dowloaded;

public:
    QLineEdit *user_edit;
    QLineEdit *pass_edit;
    TFindEdit *find_edit;
    int is_exists_dxf;
    explicit DbOpenForm(QWidget *parent = 0);
    void ShowForm();
    void WaitDownload();
    QString received;

signals:
    void StopWait();

public slots:
    void loginEvent();
    void PushOk();
    void PushCancel();
    void downloadFinished(QNetworkReply *data);
    void CheckExistsDXF(QNetworkReply *);
    void customMenuRequested(QPoint pos);
    void RightRowChanged(int , int, int , int );
    void ReceiveJpg(QNetworkReply*);
    void ReceiveHTTP(QNetworkReply *rep);

    void actionMenu_ToGlue();
    void actionMenu_ToFinish();
    void ActionMenuNamEvent(QNetworkReply *data);

//    void LoadSavedProj();
    void FindOrder(const QString &ftext);
};

#endif // DBOPENFORM_H
