#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include<tgraphcontainer.h>

#include<qmenu.h>
#include<dbopenform.h>
//#include <QSqlDatabase>

#include"tplatesarrangeform.h"
#include"tppconfig.h"

namespace Ui {
class MainWindow;
}

class DbOpenForm;
class MainWindow : public QMainWindow
{
    Q_OBJECT
private:
    DbOpenForm *dbof;
    QTimer *TimerWhenStart;
    TPlatesArrangeForm * PLA;
//    TppConfig  * PPCfg;
    int is_started;
    QString startopenfile;

protected:
    void contextMenuEvent(QContextMenuEvent *event) Q_DECL_OVERRIDE;
    void closeEvent(QCloseEvent *event);
    void showEvent(QShowEvent * event);

public:
    TCAD *cad;
//    QSqlDatabase db;


    explicit MainWindow(QString startopenfile, QWidget *parent = 0);
    ~MainWindow();
    void SetStatusMessage(QString );
    void SetSelectableLayers();


    void SetToolsVisibility(TPolyline *p);
    void SetTitle(QString s);

private slots:
    void StartTimerShot();
    void openFile();

    void ShowRam();
    void DbOpen();
    void PACOpen();
    void CfgOpen();
    void OpenPrimConf();
    void ExitProgram();
    void GenerateG();

    void cmdCI();
    void cmdCCI();
    void DoRotate();

    void ToSelectMode();
    void ToDrawLineMode();

private:
    Ui::MainWindow *ui;
    QMenu *fileMenu;
    QMenu *confMenu;
    QAction *openAct;
    QAction *confAct;
    QAction *StopMachineAct;

    QAction *ToolSelectMode;
    QAction *DrawLineMode;

    QAction *CItool, *CCItool;
    QAction *ToRotate;

    QAction *ReversePolylineAct;
    QAction *OptimizeAct;
    QAction *SetBasePoint;

    void createActions();
    void createMenus();

 public slots:

    void ZoomIn();
    void ZoomOut();

//    void video();
};

#endif // MAINWINDOW_H
