#ifndef TGRAPHCONTAINER_H
#define TGRAPHCONTAINER_H

#include "tplatesarrangeform.h"
#include<tpolyline.h>
#include<QString>
#include<qlistwidget.h>
#include<tpolylinecontainer.h>
#include <QGraphicsScene>

class ZeroCoordMarker
{
public:
    ZeroCoordMarker();
    ~ZeroCoordMarker();
    double x0, y0;
    void SetCoord(double x, double y);
    TPolyline *xline, *xlinearrow1, *xlinearrow2;
    TPolyline *yline, *ylinearrow1, *ylinearrow2;
};


class TGraphContainer
{
public:
    TPolylineContainer *Layers;
    double EXTMINX,EXTMINY,EXTMAXX,EXTMAXY;
    double EXT_W, EXT_H;
    double EX0, EY0, EX1, EY1;

    TCAD *CAD;
    TOrders orderinfo;

    void SortLayers();
    void Rotate();
    TVertex* FindNearestVertex(TPolylineContainer*pc, TPolyline* firstP);


    void OptimizeAll();
    void OptimizeLay(TPolylineContainer *pc, double *initial_x, double *initial_y);

    void AddBridges();
    void tozero();
    void SetDirectionsPc();
    void MovePC(TPolylineContainer* src, TPolylineContainer* dest);
    TPolylineContainer *last();
    TGraphContainer(TCAD*);
    ~TGraphContainer();
    void Clear();
    int LoadDxf(QString filename);
    TPolyline* NewPolyline(QString layer, QString _color);
    TPolylineContainer *NewLayer(QString layer, QString color);
    TPolylineContainer *NewLayerAtBegin(QString layer, QString _color);
    void ChangeLayer(TPolyline* _pl, QString _layer, QString _color);
    void Remove(TPolylineContainer*pc);

    TPolylineContainer* SelectLayer(QString layer);
    void SetNonselecableAll();
    void ClearAllSelectionsOnLayers();

    void CreateOffsetLinesLayer();
    TPolylineContainer *FindByNo(int no);
    void CalcSheetSize();
    void PlaceOutsize();

    TPolyline* FirstP();
    TPolyline* NextP();
    TPolylineContainer *queuePC;
    TPolyline *queueP;
};

#endif // TGRAPHCONTAINER_H
