#include "tplatesarrangeform.h"
#include "ui_tplatesarrangeform.h"

TPlatesArrangeForm::TPlatesArrangeForm(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::TPlatesArrangeForm)
{
    ui->setupUi(this);
    RAMw=0;
    RAMh=0;
    margins=5;
    move_order_flag=0;
    move_order_ptr=0;
    ui->viewcad->is_preview=1;
    Qt::WindowFlags windowFlag  = Qt::Dialog;
       windowFlag                  |= Qt::WindowMinimizeButtonHint;
       windowFlag                  |= Qt::WindowMaximizeButtonHint;
       windowFlag                  |= Qt::WindowCloseButtonHint;
    setWindowFlags(windowFlag);
    ui->splitter->setStretchFactor(0,0);
    ui->splitter->setStretchFactor(1,1);
    nam = new QNetworkAccessManager(this);
    nam2 = new QNetworkAccessManager(this);

    ui->OrderList->setStyleSheet("QTableView:item:selected {background-color: #4444aa; color: #FFFFFF}\n"
                                 "QTableView:item:selected:focus {background-color: #4444aa;}");
    ui->OrderList->setStyleSheet("QTableView:item:selected {background-color: #4444aa; color: #FFFFFF}\n"
                                         "QTableView:item:selected:focus {background-color: #4444aa;}");
    ui->OrderSelectedList->setStyleSheet("QTableView:item:selected {background-color: #4444aa; color: #FFFFFF}\n"
                                 "QTableView:item:selected:focus {background-color: #4444aa;}");
    ui->OrderSelectedList->setStyleSheet("QTableView:item:selected {background-color: #4444aa; color: #FFFFFF}\n"
                                         "QTableView:item:selected:focus {background-color: #4444aa;}");

    connect(ui->OrderList, SIGNAL(focused()), this, SLOT(tableFocused()));
    connect(ui->OrderList, SIGNAL(unfocused()), this, SLOT(tableUnFocused()));

    connect(nam2, SIGNAL(finished(QNetworkReply*)), this, SLOT(ReceivePreview(QNetworkReply*)) );
    ui->viewcad->PAF = this;
    connect(ui->viewcad, SIGNAL(MousePressEventSignal(QMouseEvent*,QPointF)), this, SLOT(SlotMousePressEvent(QMouseEvent*,QPointF)) );
    connect(ui->viewcad, SIGNAL(MouseReleaseEventSignal(QMouseEvent*)), this, SLOT(SlotMouseReleaseEvent(QMouseEvent*)));
}

TPlatesArrangeForm::~TPlatesArrangeForm()
{
    delete ui;
}

void TPlatesArrangeForm::showEvent(QShowEvent *)
{
    RAMw = ui->spinBox->value();
    RAMh = ui->spinBox_2->value();
//    ui->viewcad->OpenDXF( TCAD::CAD->pconf->get_last_opened_file() );
    ui->viewcad->ClearOrders(1);
    load_table();
    ShowRAM();
    ui->viewcad->SetOutView();

}

void TPlatesArrangeForm::on_spinBox_valueChanged(int arg1)
{
  RAMw = arg1;
  ShowRAM();
}

void TPlatesArrangeForm::ShowRAM()
{
    ui->viewcad->DisplayRAM(RAMw,RAMh);
}

void TPlatesArrangeForm::on_spinBox_2_valueChanged(int arg1)
{
    RAMh = arg1;
    ShowRAM();
}

void TPlatesArrangeForm::load_table()
{
 disconnect(nam,0,0,0);
 connect(nam, SIGNAL(finished(QNetworkReply*)), this, SLOT(ReceiveOrderList(QNetworkReply*)) );

 QUrl url = QUrl( QString( TCAD::main_url+"/work/list_prepare.php?order_list=1")   );
 nam->get(QNetworkRequest(url));
}

bool myfunction(QString i, QString j)
{
 return (i > j);
}

void TPlatesArrangeForm::ReceiveOrderList(QNetworkReply* reply)
{
  orders.clear();
 QString CurrThick;
 if( ui->ThickList->currentText() != "")
     CurrThick=ui->ThickList->currentText();

    QString string;
        if (reply->error() == QNetworkReply::NoError)
        {
         QByteArray bytes = reply->readAll();
         string=QString(bytes);
        }
        else
        {
         qDebug() << reply->errorString();
         return;
        }

        QStringList Str = string.split(char(18) );
        if(Str.count()<1) return;

        for( int i=0; i<Str.count(); i++)
        {
         QString row = Str.at(i);
         QStringList SubStr = row.split("<~!%");
         if(row.count())
         {
             TOrders *o = new TOrders( SubStr.at(0), SubStr.at(1), SubStr.at(2), SubStr.at(3), SubStr.at(5), SubStr.at(4) );
             o->is_selected=0;
             orders.append( *o );
             delete o;
         }
        }

        thick_list.clear();
        for(int i=0; i<orders.count(); i++)
        {
         int found=0;
         for(int j=0; j< thick_list.count(); j++)
             if( thick_list[j] == orders[i].base_thickness ) { found=1; break; }
         if(!found)
             thick_list.append( orders[i].base_thickness  );
        }

        std::sort(thick_list.begin(), thick_list.end(), myfunction );
//        thick_list.sort();
        ui->ThickList->clear();
        ui->ThickList->addItems(thick_list);
        ui->ThickList->setCurrentText(CurrThick);
        fill_table();
}

void TPlatesArrangeForm::fill_table()
{
        is_filling=1;
        int n = ui->OrderList->rowCount();
        for( int i = 0; i < n; i++ ) ui->OrderList->removeRow( 0 );
        n = ui->OrderSelectedList->rowCount();
        for( int i = 0; i < n; i++ ) ui->OrderSelectedList->removeRow( 0 );

        QStringList headers;
        headers << "id"<<"№"<<"Название"<<"ф"<<"1"<<"длина";
        ui->OrderList->verticalHeader()->setVisible(false);
        ui->OrderList->setColumnCount( 6 );
        ui->OrderList->setColumnHidden(0,true);
        ui->OrderList->setColumnWidth(1, 65 );
        ui->OrderList->setColumnWidth(2, 100 );
        ui->OrderList->setColumnWidth(3, 30 );
        ui->OrderList->setColumnWidth(4, 50 );
        ui->OrderList->setColumnWidth(5, 50 );
        ui->OrderList->setHorizontalHeaderLabels(headers);

        QStringList headers1;
        headers1 << "id"<<"№"<<"Название"<<"ф"<<"1"<<"длина";
            ui->OrderSelectedList->verticalHeader()->setVisible(false);
        ui->OrderSelectedList->setColumnCount( 6 );
        ui->OrderSelectedList->setColumnHidden(0,true);
        ui->OrderSelectedList->setColumnWidth(1, 65 );
        ui->OrderSelectedList->setColumnWidth(2, 100 );
        ui->OrderSelectedList->setColumnWidth(3, 30 );
        ui->OrderSelectedList->setColumnWidth(4, 50 );
        ui->OrderSelectedList->setColumnWidth(5, 50 );
        ui->OrderSelectedList->setHorizontalHeaderLabels(headers1);

        int j=0;
        for(int i=0; i<orders.count(); i++)
        {
         if( (orders.at(i).is_selected==0) && (orders.at(i).base_thickness==ui->ThickList->currentText()))
         {
             ui->OrderList->insertRow(j);
             ui->OrderList->setRowHeight(j, 20);
             ui->OrderList->setItem(j,0, new QTableWidgetItem( orders.at(i).idorder) );
             ui->OrderList->setItem(j,1, new QTableWidgetItem(orders.at(i).zak_number));
             ui->OrderList->setItem(j,2, new QTableWidgetItem(orders.at(i).CName));
             ui->OrderList->setItem(j,3, new QTableWidgetItem( orders.at(i).base_thickness) );
             ui->OrderList->setItem(j,4, new QTableWidgetItem( orders.at(i).blade_thickness) );
             ui->OrderList->setItem(j,5, new QTableWidgetItem( orders.at(i).blade_len) );
             j++;
         }
        }

        j=0;
        for(int i=0; i<orders.count(); i++)
        {
         if(orders.at(i).is_selected)
         {
             ui->OrderSelectedList->insertRow(j);
             ui->OrderSelectedList->setRowHeight(j, 20);
             ui->OrderSelectedList->setItem(j,0, new QTableWidgetItem(  orders.at(i).idorder) );
             ui->OrderSelectedList->setItem(j,1, new QTableWidgetItem(orders.at(i).zak_number));
             ui->OrderSelectedList->setItem(j,2, new QTableWidgetItem(orders.at(i).CName));
             ui->OrderSelectedList->setItem(j,3, new QTableWidgetItem( orders.at(i).base_thickness) );
             ui->OrderSelectedList->setItem(j,4, new QTableWidgetItem( orders.at(i).blade_thickness) );
             ui->OrderSelectedList->setItem(j,5, new QTableWidgetItem( orders.at(i).blade_len) );
             j++;
         }
        }
        is_filling=0;
        if(ui->OrderList->rowCount())
            ui->OrderList->selectRow(0);
}

TOrders::TOrders(QString _idorder, QString _zak_number, QString _CName, QString _base_thickness, QString _blade_thickness, QString _blade_len)
{
      idorder= _idorder;
      zak_number = _zak_number;
      CName = _CName;
      base_thickness = _base_thickness;
      blade_thickness = _blade_thickness;
      blade_len = _blade_len;
}
TOrders::TOrders()
{

}

void TPlatesArrangeForm::on_pushButton_3_clicked()
{ // вниз
      QItemSelectionModel    *selectModel;
      selectModel = ui->OrderList->selectionModel();
      QModelIndexList         indexes;
      indexes = selectModel->selectedIndexes();

      if(indexes.count()==0) return;

      int i;
      int row = indexes[0].row();
      QString idorder = ui->OrderList->item(row,0)->text();
      for(i=0; i<orders.count(); i++)
      {
         if(orders.at(i).idorder==idorder)
         {
             orders[i].is_selected = 1;
             place_to_cad(&orders[i]);
             break;
         }
      }
      fill_table();
      if( ui->OrderList->rowCount()<= row ) row = ui->OrderList->rowCount()-1;
      ui->OrderList->selectRow(row);
      for(i=0; i<ui->OrderSelectedList->rowCount(); i++)
      {
         QString idorder1 = ui->OrderSelectedList->item(i,0)->text();
         if(idorder1==idorder)
         {
             ui->OrderSelectedList->selectRow(i);
             break;
         }
      }


}

void TPlatesArrangeForm::on_pushButton_2_clicked()
{ // вверх
      QItemSelectionModel    *selectModel;
      selectModel = ui->OrderSelectedList->selectionModel();
      QModelIndexList         indexes;
      indexes = selectModel->selectedIndexes();

      if(indexes.count()==0) return;

      int row = indexes[0].row();
      QString idorder = ui->OrderSelectedList->item(row,0)->text();
      for(int i=0; i<orders.count(); i++)
      {
         if(orders.at(i).idorder==idorder)
             orders[i].is_selected = 0;
      }
      for(int i=0; i<ordersToPlace.count(); i++)
      {
         if(ordersToPlace.at(i).idorder==idorder)
             ordersToPlace[i].pc->GC->Remove(ordersToPlace.at(i).pc);
      }
      fill_table();

      if( ui->OrderSelectedList->rowCount()<= row )
            row = ui->OrderSelectedList->rowCount()-1;
      ui->OrderSelectedList->selectRow(row);
      for(int i=0; i<ui->OrderList->rowCount(); i++)
      {
         QString idorder1 = ui->OrderList->item(i,0)->text();
         if(idorder1==idorder)
         {
             ui->OrderList->selectRow(i);
             break;
         }
      }

}

void TPlatesArrangeForm::on_pushButton_clicked()
{

}


void TPlatesArrangeForm::on_OrderList_doubleClicked(const QModelIndex &index)
{
      on_pushButton_3_clicked();
}


void TPlatesArrangeForm::on_OrderSelectedList_doubleClicked(const QModelIndex &index)
{
      on_pushButton_2_clicked();
}


void TPlatesArrangeForm::tableFocused()
{
//      qDebug()<<"Focused";
}
void TPlatesArrangeForm::tableUnFocused()
{
//      qDebug()<<"UnFocused";
}

void TPlatesArrangeForm::on_OrderList_currentCellChanged(int currentRow, int currentColumn, int previousRow, int previousColumn)
{
      if(is_filling) return;
      if(currentRow<0) return;
      QString idorder = ui->OrderList->item(currentRow,0)->text();
      QUrl url( QString( TCAD::main_url+"/innerdxf/view.php?idz="+idorder+"&W=180&H=180" )  );
      nam2->get(QNetworkRequest(url));
}

void TPlatesArrangeForm::ReceivePreview(QNetworkReply* replyJpg)
{
      if (replyJpg->error() == QNetworkReply::NoError)
      {
         QByteArray bytes = replyJpg->readAll();
         QPixmap pm;
         pm.loadFromData(bytes);
         ui->PreviewIMG->setPixmap(pm);
      }
      else
      {
         qDebug() << replyJpg->errorString();
      }
}

void TPlatesArrangeForm::on_ThickList_currentTextChanged(const QString &arg1)
{
      fill_table();
}

void TPlatesArrangeForm::WaitDownload()
{
      QEventLoop eventLoop;
      connect(this, SIGNAL(StopWait()), &eventLoop, SLOT(quit()));

      QTimer timer ;//= new QTimer(this);
      connect(&timer, SIGNAL(timeout()), &eventLoop, SLOT(quit()));
      timer.setSingleShot(true);
      timer.start(5000);
      eventLoop.exec();
}

void TPlatesArrangeForm::CheckExistsDXF(QNetworkReply *reply)
{
      QString string;
      emit StopWait();
      if (reply->error() == QNetworkReply::NoError)
      {
         QByteArray bytes = reply->readAll();
         string=QString(bytes);
         is_exists_dxf = (string=="dxf") ? 1:0;
      }
      else
      {
         qDebug() << reply->errorString();
      }
}
void TPlatesArrangeForm::downloadFinished(QNetworkReply *data)
{
      QString tmp =  data->rawHeader("content-disposition");
      QStringList ff = tmp.split("filename=");
      if(ff.count()==0) {
         filename_dowloaded = "none";
         return;
      }
      filename_dowloaded = ff[1];

      emit StopWait();
      QFile localFile("open.dxf");
      if (!localFile.open(QIODevice::WriteOnly))
         return;
      localFile.write(data->readAll());
      localFile.close();
}

int TPlatesArrangeForm::LoadFile(QString idz)
{
      QUrl url;
      url = QUrl( QString( TCAD::main_url+"/work/check_files.php?idz="+idz ) );
      disconnect(nam,0,0,0);
      connect(nam, SIGNAL(finished(QNetworkReply*)), this, SLOT(CheckExistsDXF(QNetworkReply*)));
      is_exists_dxf=0;
      nam->get(QNetworkRequest(url));
      WaitDownload();

      if(is_exists_dxf)
      {
         url = QUrl( QString( TCAD::main_url+"/work/file_for_.php?idz="+idz ) );
         disconnect(nam,0,0,0);
         connect(nam, SIGNAL(finished(QNetworkReply*)), this, SLOT(downloadFinished(QNetworkReply*)));
         nam->get(QNetworkRequest(url));
         WaitDownload();
         return 1;
      }
      return 0;
}

void TPlatesArrangeForm::place_to_cad(TOrders *_order)
{
      TPolylineContainer *pc1;
//      ui->viewcad->GC->Clear();
//      ShowRAM();

      TCAD *tmpcad = new TCAD(this);


      if(LoadFile(_order->idorder))
      {
         tmpcad->OpenPreview("open.dxf","");

         TPolyline *p = tmpcad->OrdersList.first()->Layers->Polylines;
         while(p)
         {
             pc1 = ui->viewcad->OrdersList.first()->NewLayer("preview"+_order->idorder,"" );
             pc1->idorder = _order->idorder;
             TPolyline* p1 = new TPolyline();
             p1->Copy(p);
             pc1->AddPolyline(p1);
             p=p->next;
         }
         _order->pc = pc1;
         pc1->CalcOutsize();
      }

      delete tmpcad;

      TPolylineContainer* pc;
      pc=ui->viewcad->OrdersList.first()->Layers;
      while(pc)
      {
         pc->ToScene(ui->viewcad->scene);
         pc->selectable=pc->visible=1;
         pc=pc->next;
      }

      ordersToPlace.clear();
      for(int i=0; i<orders.count(); i++)
         if( orders[i].is_selected)
         {
             ordersToPlace.append(orders[i]);
             ordersToPlace.last().OrientationToDo=0;
             ordersToPlace.last().height = -ordersToPlace.last().pc->outer.height();
             ordersToPlace.last().width = ordersToPlace.last().pc->outer.width();
             ordersToPlace.last().left = 0;
             ordersToPlace.last().bottom = 0;
         }

      OptimizePlace();
}

void TPlatesArrangeForm::OptimizePlace()
{
      float shx=0, shy=0;
      float dsh=5;
      QList<TOrders> tmplist;
      if(ordersToPlace.count()==0) return;
      tmplist.append(ordersToPlace[0]);
      for(int i=1; i< ordersToPlace.count(); i++)
      {
         int j;
         for(j=0; j<tmplist.count(); j++)
         {
             if(ordersToPlace[i].pc->CalcSquare() <= tmplist[j].pc->CalcSquare() )
             {
                break;
             }
         }
         tmplist.insert(j,ordersToPlace[i]);
      }
      ordersToPlace = tmplist;

/*      tmplist.clear();
      tmplist = PlaceRecursive( ordersToPlace, 0, 0, RAMw, RAMh);
      for(int i=0; i< tmplist.count(); i++)
      {
         QPointF sh =  tmplist[i].pc->CalcZeroOffset();
         if(tmplist[i].OrientationToDo) tmplist[i].pc->Rotate(1);
         tmplist[i].pc->Move(-sh.x()+tmplist[i].left, -sh.y() + tmplist[i].bottom );

      }
*/
      for(int i=0; i< ordersToPlace.count(); i++)
      {
         TPolylineContainer* pc = ordersToPlace[i].pc;
          QPointF sh =  pc->CalcZeroOffset();
          pc->Move(-sh.x() + shx, -sh.y()+shy);
          shx += pc->outer.width() + dsh;
          ordersToPlace[i].OrientationToDo=0;
          ordersToPlace[i].height = -ordersToPlace[i].pc->outer.height();
          ordersToPlace[i].width = ordersToPlace[i].pc->outer.width();
          ordersToPlace[i].left = ordersToPlace[i].pc->outer.left();
          ordersToPlace[i].bottom = ordersToPlace[i].pc->outer.bottom();
      }

}

QPoint TPlatesArrangeForm::CalcListSquare(QList<TOrders> src)
{
      float x0=1e25,y0=1e25;
      float x1=0,y1=0;
      for(int i=0; i<src.count(); i++)
      {
          if(x0>src[i].left) x0=src[i].left;
          if(y0>src[i].bottom) y0=src[i].bottom;

          if(x1<src[i].left) x1=src[i].left+src[i].width;
          if(y1<src[i].bottom) y1=src[i].bottom+src[i].height;
      }
      return QPoint(x1-x0, y1-y0);
}

void TPlatesArrangeForm::RotateOrder(TOrders* src)
{
      if( src->OrientationToDo == 0 )
          src->OrientationToDo = 1;
      else
          src->OrientationToDo = 0;
      float w = src->height;
      src->height = src->width;
      src->width = w;
}

QList<TOrders> TPlatesArrangeForm::PlaceRecursive(  QList<TOrders> src,   QList<TOrders> *retfree, float left, float bottom, float width, float height  )
{
      QList<TOrders> ret;
/*
      QList<TOrders> ordersfree;

            for(int ii=0; ii< src.count(); ii++)
      {

          QList<TOrders> prep;
          for(int i=1; i<src.count(); i++)
             prep.append(src[i]);
          ret = PlaceRecursive(prep, &ordersfree, left + src[0].left + src[0].width + margins, bottom, width - src[0].width - margins, src[0].height);
          if(ret.count())
          {
             QList<TOrders> ret1 = PlaceRecursive(ret, &ordersfree, left, bottom + src[0].height+margins, left + width, height - src[0].height - margins);
             for(int i=0; i<ret1.count(); i++)
                ret.append(ret1[i]);
          }

      }

      int i=src.count();
      while( i )
      {
          if(src[0].width > width)
          {
             if(src[0].height > width)
                src.removeFirst();
             else
                RotateOrder(&src[0]);
          }
          if(src[0].height > height)
          {
             if(src[0].width > height)
                src.removeFirst();
             else
                RotateOrder(&src[0]);
          }
          i--;
      }

      QList<TOrders> ret;
      if(src.count()<=1)
      {
          if(src.count()==0) return ret;
          src[0].left = left;
          src[0].bottom = bottom;
          return src;
      }

      ret.insert(0, src[0]);
*/
      return ret;
}

void TPlatesArrangeForm::SlotMousePressEvent(QMouseEvent * event, QPointF posf)
{
      if( event->buttons() == Qt::LeftButton )
      {
          if(event->modifiers() == Qt::ControlModifier)
          {
             for(int i=0; i< ordersToPlace.count(); i++)
              {
                 if( ordersToPlace[i].pc->outer.contains(QPoint(posf.x(), posf.y())))
                 {
                    ordersToPlace[i].pc->Rotate(1);
                    qreal l =  ordersToPlace[i].pc->outer.left();
                    qreal b =  ordersToPlace[i].pc->outer.bottom();
                    move_order_ptr = &ordersToPlace[i];
                    move_order_ptr->pc->CalcOutsize();
                    move_order_ptr->pc->Move(-move_order_ptr->pc->outer.left() + l , -move_order_ptr->pc->outer.bottom() + b);
                         move_order_ptr->height  = -move_order_ptr->pc->outer.height();
                         move_order_ptr->width   = move_order_ptr->pc->outer.width();
                         move_order_ptr->left    = move_order_ptr->pc->outer.left();
                         move_order_ptr->bottom  = move_order_ptr->pc->outer.bottom();

                    break;
                 }
              }
          }
          if(event->modifiers() == Qt::NoModifier)
          {
              for(int i=0; i< ordersToPlace.count(); i++)
              {
                 if( ordersToPlace[i].pc->outer.contains(QPoint(posf.x(), posf.y())))
                 {
                    move_order_ptr = &ordersToPlace[i];
                    move_order_flag=1;
                    move_order_point = posf;
                    new_move_order_point = posf;
                    for(int k=0; k < ui->OrderSelectedList->rowCount(); k++ )
                    {
                        if(ui->OrderSelectedList->item(k,0)->text() == ordersToPlace[i].pc->idorder)
                            ui->OrderSelectedList->setCurrentCell(k,1);
                    }
                    break;
                 }
              }
          }
      }
}

void TPlatesArrangeForm::SlotMouseReleaseEvent(QMouseEvent * event)
{
     move_order_flag=0;
      if(move_order_ptr==0) return;
      move_order_ptr->height  = -move_order_ptr->pc->outer.height();
      move_order_ptr->width   = move_order_ptr->pc->outer.width();
      move_order_ptr->left    = move_order_ptr->pc->outer.left();
      move_order_ptr->bottom  = move_order_ptr->pc->outer.bottom();
}

int TPlatesArrangeForm::SlotMouseMoveEvent(QMouseEvent * event, QPointF posf)
{
      const float mult1=1;
      const float mult2=3;

      if( move_order_flag==1 )
     {
          QPointF dp = posf - move_order_point;

          for(int i=0; i < ordersToPlace.count(); i++)
          {
              qreal oleft=ordersToPlace[i].left;
              qreal oright=ordersToPlace[i].left + ordersToPlace[i].width;
              qreal obottom=ordersToPlace[i].bottom;
              qreal otop=ordersToPlace[i].bottom + ordersToPlace[i].height;
              qreal sleft = move_order_ptr->left;
              qreal sright = move_order_ptr->left+ move_order_ptr->width;
              qreal sbottom = move_order_ptr->bottom;
              qreal stop = move_order_ptr->bottom + move_order_ptr->height;
              qreal sptr_bottom = move_order_ptr->pc->outer.bottom();
              qreal sptr_top = move_order_ptr->pc->outer.top();
              qreal sptr_left = move_order_ptr->pc->outer.left();
              qreal sptr_right = move_order_ptr->pc->outer.right();

              if( &ordersToPlace[i] != move_order_ptr )
              {
                 if(( (oleft + margins*mult1 ) > (sright + dp.x()) ) && ( (oleft - margins*mult2 ) < (sright + dp.x())) )
                 {
                    if(((obottom-1 < sptr_bottom ) && (otop+1 > sptr_bottom ) ) || ( (otop+1>sptr_top) && (obottom-1<sptr_top) ) )
                        posf.setX( oleft - margins - sright + move_order_point.x() );
                 }
                 if(( (oright - margins*mult1 ) < (sleft + dp.x()) ) && ( (oright + margins*mult2 ) > (sleft + dp.x())) )
                 {
                    if(((obottom-1 < sptr_bottom ) && (otop+1 > sptr_bottom ) ) || ( (otop+1>sptr_top) && (obottom-1<sptr_top) ) )
                        posf.setX( oright + margins - sleft + move_order_point.x() );
                 }

                 if(( (obottom + margins*mult1 ) > (stop + dp.y()) ) && ( (obottom - margins*mult2 ) < (stop + dp.y())) )
                 {
                    if(((oleft-1 < sptr_left ) && (oright+1 > sptr_left ) ) || ( (oright+1 > sptr_left) && (oleft-1 < sptr_right) ) )
                        posf.setY( obottom - margins - stop + move_order_point.y() );
                 }
                 if(( (otop - margins*mult1 ) < (sbottom + dp.y()) ) && ( (otop + margins*mult2 ) > (sbottom + dp.y())) )
                 {
                    if(((oleft-1 < sptr_left ) && (oright+1 > sptr_left ) ) || ( (oright+1 > sptr_left) && (oleft-1 < sptr_right) ) )
                        posf.setY( otop + margins - sbottom + move_order_point.y() );
                 }
              }

              if(( (-margins*mult2 ) < (sleft + dp.x()) ) && ( (margins*mult2 ) > (sleft + dp.x())) )
                 posf.setX( -sleft + move_order_point.x() );

              if(( (-margins*mult2 ) < (sbottom + dp.y()) ) && ( (margins*mult2 ) > (sbottom + dp.y())) )
                 posf.setY( -sbottom + move_order_point.y() );
          }

          MoveOrder(move_order_ptr, posf);
          return 1;
     }
     return 0;
}

void TPlatesArrangeForm::MoveOrder(TOrders *o, QPointF p)
{
     o->pc->Move( p.x() - new_move_order_point.x(), p.y() - new_move_order_point.y());
     new_move_order_point = p;
}

void TPlatesArrangeForm::on_buttonBox_accepted()
{
     TCAD::CAD->ClearOrders(0);
     for(int i=0; i<ordersToPlace.count(); i++)
     {
          TGraphContainer *gc = new TGraphContainer(TCAD::CAD);
          gc->Layers = ordersToPlace[i].pc;
          ordersToPlace[i].pc->GC = gc;
          gc->Layers->next=0;
          gc->Layers->prev=0;
          gc->orderinfo = ordersToPlace[i];
          TCAD::CAD->OrdersList.append(gc);
     }
     TCAD::CAD->PrepareGC();
     TCAD::CAD->PrepareAll(0);
}

