#ifndef TPLATESARRANGEFORM_H
#define TPLATESARRANGEFORM_H

#include <QDialog>
#include <QNetworkAccessManager>
#include<QList>
#include<QTableWidget>
#include "tpolylinecontainer.h"
#include"ttablewidget.h"


namespace Ui {
class TPlatesArrangeForm;
}
class TOrders;

class TPlatesArrangeForm : public QDialog
{
    Q_OBJECT

public:
    QNetworkAccessManager *nam;
    QNetworkAccessManager *nam2;

    explicit TPlatesArrangeForm(QWidget *parent = nullptr);
    ~TPlatesArrangeForm();
    void showEvent(QShowEvent *);
    void load_table();
    void fill_table();

    int SlotMouseMoveEvent(QMouseEvent * event, QPointF posf);
    void MoveOrder(TOrders *o, QPointF p);

signals:
    void StopWait();
private slots:
    void on_spinBox_valueChanged(int arg1);
    void on_spinBox_2_valueChanged(int arg1);
    void ReceiveOrderList(QNetworkReply*);
    void ReceivePreview(QNetworkReply*);
    void CheckExistsDXF(QNetworkReply *reply);
    void downloadFinished(QNetworkReply *data);
    void WaitDownload();
    int LoadFile(QString idz);

    void place_to_cad(TOrders *_order);
    void OptimizePlace();
    QPoint CalcListSquare(QList<TOrders> src);
    void RotateOrder(TOrders *src);
    QList<TOrders> PlaceRecursive(QList<TOrders> src, QList<TOrders> *retfree, float left, float bottom, float width, float height);
    void on_pushButton_3_clicked();
    void on_pushButton_2_clicked();
    void on_OrderList_doubleClicked(const QModelIndex &index);
    void on_OrderSelectedList_doubleClicked(const QModelIndex &index);
    void tableFocused();
    void tableUnFocused();
    void on_OrderList_currentCellChanged(int currentRow, int currentColumn, int previousRow, int previousColumn);
    void on_ThickList_currentTextChanged(const QString &arg1);

    void SlotMousePressEvent(QMouseEvent * event, QPointF posf);
    void SlotMouseReleaseEvent(QMouseEvent * event);

    void on_pushButton_clicked();

    void on_buttonBox_accepted();

protected:
private:
    int is_filling;
    float RAMw;
    float RAMh;
    int is_exists_dxf;
    float margins;
    int move_order_flag;
    QPointF move_order_point;
    QPointF new_move_order_point;
    TOrders *move_order_ptr;

    QString filename_dowloaded;
    QList<TOrders> orders;
    QList<TOrders> ordersToPlace;
    QStringList thick_list;
    Ui::TPlatesArrangeForm *ui;
    void ShowRAM();
};


class TOrders
{
public:
    explicit TOrders(QString _idorder, QString _zak_number, QString _CName, QString _base_thickness, QString _blade_thickness, QString _blade_len);
    explicit TOrders();
    QString idorder;
    QString zak_number;
    QString CName;
    QString blade_len;
    QString base_thickness;
    QString blade_thickness;
    float left;  // left bottom point of square
    float bottom;
    float height; // width height
    float width;
//    QPointF shift;
    int OrientationToDo;
    int is_selected;
    TPolylineContainer *pc;
};




#endif // TPLATESARRANGEFORM_H
