#ifndef TPLTOOLS_H
#define TPLTOOLS_H

#include <QWidget>
#include<QDoubleSpinBox>
#include<QVBoxLayout>
#include<QLabel>
#include<QCheckBox>
#include<QPushButton>
#include<QLineEdit>
#include<QListWidget>
#include<QStringList>
#include<QTableView>
#include<QVector>
#include<QString>
#include<QModelIndex>
#include<QModelIndexList>

#include <QTableWidget>
#include "qcombobox.h"
#include "tgraphcontainer.h"
#include"tpolyline.h"

class TLayerModel : public QAbstractTableModel
{
private:
    int columnCount(const QModelIndex &parent) const;
    QVariant data(const QModelIndex &index, int role) const;

    QVector<QString> Lv;
    QVector<QString> Cv;
    QVector<int> Lvisible;
public:
    int rowCount(const QModelIndex &parent) const;
    TGraphContainer *gc;
    int orderrow;
//    TLayerModel();
    void Fill();

};

class PLineModel;

class LayersTable : public QTableView
{
    Q_OBJECT
private:
    int SelectedRow;
public:
    LayersTable();
    TLayerModel *LM;

    PLineModel *plm;
    void SelectSlavePLContainer(TPolylineContainer* pc);
    virtual void keyPressEvent(QKeyEvent *event);
    virtual void selectionChanged(const QItemSelection &selected, const QItemSelection &deselected);
public slots:
    void DoubleClicked(const QModelIndex &index);
    void MoveSelDown();
    void MoveSelUp();
    void MoveSelDownDown();
    void MoveSelUpUp();
signals:
};


class PLineModel : public QAbstractTableModel
{
private:
    int columnCount(const QModelIndex &parent) const;
    QVariant data(const QModelIndex &index, int role) const;

    QVector<QString> Lv;
    QVector<int> Lvisible;
public:
    TPolylineContainer *pc;
    int rowCount(const QModelIndex &parent) const;
    void Fill();
};

class PLineTable : public QTableView
{
    Q_OBJECT
private:
    int SelectedRow;
public:
    int CareSelectPolyline;
    PLineTable();
    PLineModel *plmodel;

    virtual void keyPressEvent(QKeyEvent *event);
        virtual void selectionChanged(const QItemSelection &selected, const QItemSelection &deselected);
public slots:
    void DoubleClicked(const QModelIndex &index);
    void MoveSelDown();
    void MoveSelUp();
    void MoveSelDownDown();
    void MoveSelUpUp();
signals:
};

class TListTool : public QWidget
{
    Q_OBJECT

private:
    QAction *sortHmenu;
    QAction *sortVmenu;
    QAction *sortSqaremenu;
    QAction *calcLenMenu;
protected:
    void contextMenuEvent(QContextMenuEvent *event) Q_DECL_OVERRIDE;
public:
    TListTool();

    QTableWidget OrdersTable;
    QComboBox ThickBase;
    TLayerModel LayersModel;
    LayersTable Layers;

    PLineModel PLm;
    PLineTable PLT;

    void DisplayList();
    void SelectPolyline(TPolyline* p);

    void FillOrderTable();

signals:

public slots:
    void RefreshLayers();
    void DoSortH();
    void DoSortV();
    void DoSortSqare();
    void DoCalcLength();
    void OrderSelected(int currRow, int currCol, int, int);
    void ThickSelected(int row);

    void OrderUp(bool);
    void OrderDown(bool);
};


#endif // TPLTOOLS_H
