#include "tpolyline.h"
#include<qdebug.h>
#include<QStyleOptionGraphicsItem>
#include<QGraphicsSceneHoverEvent>
#include "tcad.h"


double TPolyline::dot_shift=0;

double Sign(double x)
{
    return (x<0)? -1:1;
}

double CalcBulgeAbs(double a1, double a2)
{
 double aa =  a2 - a1;
  if( a2 < a1 )
   aa = a2 - a1 + 2*M_PI;
  double	b = tan( (aa)/4 );
  return b;
}


double LineLen(double x, double y, double x1, double y1)
{
  return sqrt((x - x1)*(x - x1)+ (y - y1)*(y - y1));
}

double VectorToRadial(double x1, double y1, double x2, double y2)
{
 double a, _a;
 if( x1-x2 != 0) _a = atan( ABS((y1 - y2)/(x1 - x2)) );
 else
  {  if(y1<=y2)
       _a=M_PI/2;
     else
       _a=3*M_PI/2;
     return _a;
  }
 a=_a;
 if( x1<x2 )
 {
   if(y1>y2)
    a = 2*M_PI-a;
 }
 if( x1>=x2 )
 {
  if( y1>y2 )
    a = M_PI+_a;
  else
    a = M_PI-_a;
 }

 return a;
}

double vector_to_point_angle(double x1, double y1, double x2, double y2, double xd, double yd )
{
  double a1,a2, a;
   a1 = VectorToRadial(x1,y1,x2,y2);
   a2 = VectorToRadial(x2,y2,xd,yd);

   a = a2-a1;
   if(a<-M_PI) a = 2*M_PI+a;
   if(a>M_PI) a = a - 2*M_PI;

   return a;
}

int TouchLine(double xx, double yy, double r, double x, double y, double x1, double y1)
{
    double a, a1;

     double l = sqrt((x - x1)*(x - x1)+ (y - y1)*(y - y1));
     if( x-x1 != 0) a = atan( (y - y1)/(x - x1) ); else a=M_PI/2;
     double l1 = sqrt((xx - x1)*(xx - x1)+ (yy - y1)*(yy - y1));
     if(xx-x1 != 0) a1 = atan( (yy - y1)/(xx - x1) ); else a1=M_PI/2;
     double r1 = ABS(sin(a1-a)*l1);

     if ((r>=r1) && (l1<l) && ((Sign(xx-x1)==Sign(x-x1))|| (x-x1==0) ) && ((Sign(yy-y1)==Sign(y-y1)) || (y-y1==0)) )
       return 1;
     else return 0;
}

int TouchArcVertex(TVertex* v, double xx, double yy, double _r)
{
     double a;
     a = VectorToRadial(v->x0,v->y0, xx,yy);
     double r1 = sqrt((xx - v->x0)*(xx - v->x0)+ (yy - v->y0)*(yy - v->y0));

/*     double r2 = sqrt((xx - v->x)*(xx - v->x)+ (yy - v->y)*(yy - v->y));
     if(r2<_r) return 1;

     if(v->next)
     {
         r2 = sqrt((xx - v->next->x)*(xx - v->next->x)+ (yy - v->next->y)*(yy - v->next->y));
         if(r2<_r) return 1;
     }
*/

     if(  ( v->r-_r < r1 ) && ( r1 < v->r+_r ) )
     {
       if( (v->a1 > v->a2) && (a < v->a1) ) a+=M_PI*2;
       if(( (v->a1<v->a2) && (v->a1 < a) && (a<v->a2) ) ||
            ((v->a1>v->a2) && (v->a1 < a) && ( a < v->a2+2*M_PI )) )
        return 1;
       else
        return 0;
     }
     else
      return 0;
}


int ComparePolylines(TPolyline*p1, TPolyline *p2)
{
/*  TVertex * v1 = p1->firstV;
  TVertex * v2 = p2->firstV;
  while(v1->next)
  {
      float l1 = qRound(v1->len*100);
      float l2 = qRound(v2->len*100);
      if(l1 == l2)
      {
          if(v1->next && v2->next && v1->next->next && v2->next->next)
          {
             float a1,a2;
              a1 = vector_to_point_angle(v1->x, v1->y, v1->next->x, v1->next->y, v1->next->next->x, v1->next->next->y);
              a2 = vector_to_point_angle(v2->x, v2->y, v2->next->x, v2->next->y, v2->next->next->x, v2->next->next->y);
              a1 = qRound(100*a1);
              a2 = qRound(100*a2);

              if( a1!=a2 )
                return 0;

              l1=0; l2=0;
              while( (l1 = TMakeRuleChain::FindBridges(v1,l1,&p1))>0 )
              {
                  l1 = qRound(l1*10);
                  l2 = TMakeRuleChain::FindBridges(v2,l2,&p2);
                  l2 = qRound(l2*10);
                  if(l1!=l2)
                      return 0;
                  l1+=0.1;
                  l2+=0.1;
              }
          }
      }
      else
          return 0;

      if(!v2->next) return 0;
      v1 = v1->next;
      v2 = v2->next;
  }
*/


  return 1;
}


int Intersection(double ax1, double ay1, double ax2, double ay2,
  double bx1, double by1, double bx2, double by2)
{
double v1,v2,v3,v4;
   v1=(bx2-bx1)*(ay1-by1)-(by2-by1)*(ax1-bx1);
   v2=(bx2-bx1)*(ay2-by1)-(by2-by1)*(ax2-bx1);
   v3=(ax2-ax1)*(by1-ay1)-(ay2-ay1)*(bx1-ax1);
   v4=(ax2-ax1)*(by2-ay1)-(ay2-ay1)*(bx2-ax1);
   return (v1*v2<0) && (v3*v4<0);
}


// --------------------------- TVertex -------------------------------------------

TVertex::TVertex()
{
  x=0;
  y=0;
  next=prev=0;
  bulge = 0;
  a1=a2=x0=y0=r=0;
};
TVertex::TVertex(double _x, double _y, double _b)
{
  x=_x;
  y=_y;
  bulge = _b;
  next=prev=0;
  a1=a2=x0=y0=r=0;
};
TVertex* TVertex::last()
{
   TVertex *ptr=this->next;
   while(ptr->next) ptr = ptr->next;
   return ptr;
}

TVertex TVertex::operator=(TVertex s)
{
  x = s.x;
  y = s.y;
  bulge = s.bulge;
  a1 = s.a1;
  a2 = s.a2;
  x0 = s.x0;
  y0 = s.y0;
  r = s.r;
  return *this;
}

double TVertex::LenToPoint(double _x, double _y)
{
if( bulge!=0 )
 {
  if(r==0) return 0;

  double s = LineLen(_x,_y,x,y)/(2*r);
  if (s>1) { s=1; }
  double theta = 2*asin( s );
  if( ABS(bulge)>1 ) theta = 2*M_PI-theta;
  double Len = r * theta;
  return Len;
 }
 else
 {
  return LineLen(x,y,_x,_y);
 }

}

double TVertex::TouchBridgeOnSegment(double xx, double yy)
{
    TVertex*v=this;
    if(!v->next) return 0;
    if(v->bulge==0)
     {
         if(TouchLine(xx,yy, 0.2,v->x, v->y,v->next->x,v->next->y))
         return LineLen(v->x,v->y,xx,yy);
     }
    else
     {
         if(TouchArcVertex(v,xx,yy, 0.2))
         return v->LenToPoint(xx,yy);
     }
 return 0;
}



double TVertex::Xmatrix(double _X )
{
    return _X - TCAD::CAD->MatrixShiftX0;
}

double TVertex::Ymatrix(double _Y )
{
    return _Y - TCAD::CAD->MatrixShiftY0;
}

TVertex TVertex::halfline()
{
    double _x = (x + next->x)/2;
    double _y = (y + next->y)/2;
    TVertex rv(_x,_y,0);
    return rv;
}

// ------------------------ TPolyline ---------------------------------
TPolyline::TPolyline() :  QGraphicsPathItem()
{

 type=0;
 PartContour=0;

 is_copy=0;
 make_cnt=1;

 firstV=0;
 next=prev=0;
 path=0;
 Vpath=0;
 tryConcatError=0;
 onMouseSegment=0;
 SelectedSegment=0;
 onMouseV=0;
 SelectedVertex=0;
 elong1=elong2=0;
 ismus1=ismus2=0;

 setZValue(10);
 setFlags(ItemIsSelectable);
 setAcceptHoverEvents(true);
}

TPolyline::~TPolyline()
{
    TVertex *v1, *v = firstV;
    while(v)
    {   v1=v;
        v=v->next;
        delete v1;
    }
    firstV=0;
    if(path) delete path;
    if(Vpath) delete Vpath;
}

TPolyline *TPolyline::last()
{
   TPolyline *ptr=this;
   while(ptr->next) ptr = ptr->next;
   return ptr;
}

TVertex *TPolyline::lastV()
{
   TVertex *v=firstV;
   while(v->next) v = v->next;
   return v;
}


void TPolyline::Copy(TPolyline* ps)
{
    this->color = ps->color;
    TVertex *v = ps->firstV;
    while(v)
    {
        this->AddVertex(v->x,v->y,v->bulge);
        v=v->next;
    }
}


enum IntersectResult {  PARALLEL , COINCIDENT ,NOT_INTERSECTING, INTERSECTING  };

/** Определение координат точки пересечения двух отрезков.
Метод возврашает :
    PARALLEL - если парралельны
    COINCIDENT - если совпали (один из отрезков лежит на другом)
    NOT_INTERSECTING - если непересеклись в отрезках
    INTERSECTING - если пересеклись
    в x и y передаётся координата пересечения

**/
int LineIntersection(
double begin_x_, double begin_y_,
double end_x_, double end_y_,
double other_line_begin_x_, double other_line_begin_y_,
double other_line_end_x_, double other_line_end_y_,
double &x, double &y
                 ){


        double denom = ((other_line_end_y_ - other_line_begin_y_)*(end_x_ - begin_x_)) -
                      ((other_line_end_x_ - other_line_begin_x_)*(end_y_ - begin_y_));

        double nume_a = ((other_line_end_x_ - other_line_begin_x_)*(begin_y_ - other_line_begin_y_)) -
                       ((other_line_end_y_ - other_line_begin_y_)*(begin_x_ - other_line_begin_x_));

        double nume_b = ((end_x_ - begin_x_)*(begin_y_ - other_line_begin_y_)) -
                        ((end_y_ - begin_y_)*(begin_x_ - other_line_begin_x_));
        if(abs(denom) <= 0.0001)
        {
            if(abs(nume_a) <= 0.0001 && abs(nume_b) <= 0.0001)
            {
                return COINCIDENT;
            }
            return PARALLEL;
        }

        double ua = nume_a / denom;
        double ub = nume_b / denom;

        if(ua >= 0.0 && ua <= 1.0 && ub >= 0.0 && ub <= 1.0)
        {
            // получаем точку пересечения
            x = begin_x_ + ua*(end_x_ - begin_x_);
            y = begin_y_ + ua*(end_y_ - begin_y_);

            return INTERSECTING;
        }

        return NOT_INTERSECTING;
    }


void TPolyline::_FindIntersectionsShorten(double* b, double* e)
{
    TPolylineContainer* pc = plcontainer->GC->SelectLayer("WideRules");
    if(!pc) return;
    TPolyline* p = pc->Polylines;

    *b=0;
    *e=0;
    int rez;

    double isx,isy;

    while(p)
    {
      if(p->firstV->bulge==0)
      {
        rez = LineIntersection(this->firstV->x, this->firstV->y, this->firstV->next->x, this->firstV->next->y,
            p->firstV->x, p->firstV->y, p->firstV->next->x, p->firstV->next->y, isx,isy);
        if( rez == INTERSECTING )
        {
          float l = LineLen( firstV->x, firstV->y, isx, isy );
          if(l < firstV->len/2)
           {
             if(*b<l) *b = l;

           }
        }

        rez = LineIntersection(this->lastV()->prev->x, this->lastV()->prev->y,
                               this->lastV()->x, this->lastV()->y,
            p->firstV->x, p->firstV->y, p->firstV->next->x, p->firstV->next->y, isx,isy);
        if( rez == INTERSECTING )
        {
          TVertex *vlast = this->lastV();
          float l = LineLen( vlast->x, vlast->y, isx, isy );
          float l1 = vlast->prev->len;

          if(l < l1/2)
           {
             if(*e<l) *e = l;
           }
        }

      }
     // if(*b && *e) return;
      p = p->next;
    }
}


void TPolyline::FindIntersectionsShorten(double* _b, double* _e)
{
    TPolylineContainer *plleft = new TPolylineContainer("$@#22",0,0);
    plleft->CreateOffsetLinesLeft(this);

    TPolylineContainer *plright = new TPolylineContainer("$@#22",0,0);
    plright->CreateOffsetLinesRight(this);

    double bmin=0, emin=0;
    double b=0, e=0;
    plleft->Polylines->_FindIntersectionsShorten(&b,&e);
    bmin=b;
    emin=e;
    plright->Polylines->_FindIntersectionsShorten(&b,&e);
    if( (b>0) && (bmin<b)) bmin=b;
    if( (e>0) && (emin<e)) emin=e;

    plleft->Polylines->last()->_FindIntersectionsShorten(&b,&e);
    if( (b>0) && (bmin<b)) bmin=b;
    if( (e>0) && (emin<e)) emin=e;
    plright->Polylines->last()->_FindIntersectionsShorten(&b,&e);
    if( (b>0) && (bmin<b)) bmin=b;
    if( (e>0) && (emin<e)) emin=e;

    *_b = -bmin-0.5;  //TCAD::CAD->bender->BigToCutOffset;
    *_e = -emin-0.5;  //TCAD::CAD->bender->BigToCutOffset;

    delete plleft;
    delete plright;
}

TVertex* TPolyline::TouchSegment(double xx, double yy, double _r)
{
 TVertex *v = firstV;
/* if(type==1)
 {
     return 0;
 }
*/
 if(!v) return 0;
 while(v->next)
 {

     if(v->bulge==0)
  {
      if(TouchLine(xx,yy,_r,v->x, v->y,v->next->x,v->next->y))
          return v;
  }
  else
  {
      if(TouchArcVertex(v,xx,yy,_r))
          return v;
  }
  v=v->next;
 }
 return 0;
}


void TPolyline::CalcBulge(TVertex* v1, TVertex* v2)
{
    double theta =  4* atan(v1->bulge) ;
    double gamma = M_PI/2- ABS(theta)/2;
    double a = VectorToRadial(v1->x,v1->y, v2->x, v2->y);
    double c = sqrt((v2->x - v1->x)*(v2->x - v1->x) + (v2->y - v1->y)*(v2->y - v1->y));
    v1->r = c*(1 + v1->bulge*v1->bulge)/ABS(4*v1->bulge);
    v1->x0 = v1->x + ( v1->r*cos(a+gamma*Sign(v1->bulge)) );
    v1->y0 = v1->y + ( v1->r*sin(a+gamma*Sign(v1->bulge)) );

    double aa1,aa2;
    aa2= VectorToRadial( v1->x0, v1->y0, v1->x, v1->y );
    aa1= VectorToRadial( v1->x0, v1->y0, v2->x, v2->y );


    if( v1->bulge<0)    {  v1->a1=aa1; v1->a2=aa2;  }
    else 	 		{   v1->a1=aa2; v1->a2=aa1;  }

    if(v1->r < 0.5)
    {
       v1->bulge=0;
       v1->r=0;
    }
    if( (v1->bulge!=0) && (ABS(v1->bulge)<0.005) ) v1->bulge=0;
}

TVertex* TPolyline::AddVertex( double x,  double y,  double b)
{
  if(firstV==0)
  {
      path=new QPainterPath(QPointF(x,-y));
      firstV=new TVertex(x,y,b);
      setPath(*path);
      CalcLength();
      return firstV;
  } else
  {
      TVertex *v = firstV;
      while(v->next) v=v->next;
      v->next= new TVertex(x,y,b);
      v->next->prev=v;

      if(v->bulge) CalcBulge(v,v->next);


      if(v->bulge==0)
      {
       path->lineTo(v->next->x, -v->next->y);
      }
      else
      {
        double x= v->x0 - v->r;
        double y= -v->y0 - v->r;
        double  a1 = 180/M_PI * v->a1;
        double  a2 = 180/M_PI * v->a2;

        double da=a2-a1;
        if(a1>a2)
                 da = a2+(360-a1);

        if(v->bulge<0)
            path->arcTo(x, y, 2*v->r, 2*v->r,a2,-da);
        else
            path->arcTo(x, y, 2*v->r, 2*v->r,a1,da);
      }
      setPath(*path);
      CalcLength();
      return v->next;
  }
}

void TPolyline::AddArc( double x,  double y,  double r,  double a1,  double a2)
{

  firstV = new TVertex();
  TVertex *v=firstV;
  v->x0=x;
  v->y0=y;
  v->r =r;
  v->a1=a1*M_PI/180;
  v->a2=a2*M_PI/180;

  v->x = v->x0+v->r*cos(a1*M_PI/180);
  v->y = v->y0+v->r*sin(a1*M_PI/180);


  v->next = new TVertex();
  v->next->prev=v;
  v->next->x = v->x0+v->r*cos(a2*M_PI/180);
  v->next->y = v->y0+v->r*sin(a2*M_PI/180);

  v->bulge = CalcBulgeAbs(v->a1,v->a2);

  path=new QPainterPath(QPointF(v->x,-v->y));

  double xx= v->x0 - v->r;
  double yy= -v->y0 - v->r;

  double da=a2-a1;
  if(a1>a2)
           da = a2+(360-a1);

  if(v->bulge<0)
      path->arcTo(xx, yy, 2*v->r, 2*v->r,a2,-da);
  else
      path->arcTo(xx, yy, 2*v->r, 2*v->r,a1,da);

//  path->lineTo(v->next->x,-v->next->y);
  setPath(*path);
  CalcLength();
}

void TPolyline::close()
{
    AddVertex(firstV->x,firstV->y,firstV->bulge);
}

void TPolyline::PathRepair()
{
  delete path;

/*    if(type==1)
    {
        path=new QPainterPath();
        path->addEllipse(QPoint(cx,-cy),cr,cr);
        return;
    }
*/
    TVertex *v = firstV;
    if(!v) return;

    path=new QPainterPath(QPointF(v->x,-v->y));
    setPath(*path);
    while(v->next)
    {
        if(v->bulge) CalcBulge(v,v->next);


        if(v->bulge==0)
        {
         path->lineTo(v->next->x, -v->next->y);
        }
        else
        {
          double x= v->x0 - v->r;
          double y= -v->y0 - v->r;
          double  a1 = 180/M_PI * v->a1;
          double  a2 = 180/M_PI * v->a2;

          double da=a2-a1;
          if(a1>a2)
                   da = a2+(360-a1);

          if(v->bulge<0)
              path->arcTo(x, y, 2*v->r, 2*v->r,a2,-da);
          else
              path->arcTo(x, y, 2*v->r, 2*v->r,a1,da);
        }

        setPath(*path);
        CalcLength();
        v = v->next;
    }
}

void TPolyline::SetVpath(TVertex *v)
{
    if(Vpath)
      {
         delete Vpath;
         Vpath=0;
      }

//  if(type==0)
  {
    Vpath=new QPainterPath(QPointF(v->x,-v->y));
          if(v->bulge==0)
          {
           Vpath->lineTo(v->next->x, -v->next->y);
          }
          else
          {
            double x= v->x0 - v->r;
            double y= -v->y0 - v->r;
            double a1 = 180/M_PI * v->a1;
            double a2 = 180/M_PI * v->a2;

            double da=a2-a1;
            if(a1>a2)
                     da = a2+(360-a1);

            if(v->bulge<0)
                Vpath->arcTo(x, y, 2*v->r, 2*v->r,a2,-da);
            else
                Vpath->arcTo(x, y, 2*v->r, 2*v->r,a1,da);
          }
  }

//  if(type==1)
//  {
//    Vpath=new QPainterPath();
//    Vpath->addEllipse(QPoint(cx,cy),cr,cr);
//  }

}

double TPolyline::CalcLength()
{
  TVertex * v = firstV;
  double l=0, L1 = 0;
  while( v && v->next )
  {
    if( v->bulge==0 )
    {
      l = sqrt((v->x - v->next->x)*(v->x - v->next->x)+ (v->y - v->next->y)*(v->y - v->next->y));
      L1+=l;
    }
    else
    {
      double da;
      if( v->a2<v->a1 ) da = v->a2-v->a1+M_PI*2;
      else da = v->a2 - v->a1;
      l = 2*M_PI*v->r* (da/(2*M_PI));
      L1+=l;
    }
//    l = qRound(l*1000);
    v->len= l;//  /1000;
    v=v->next;
  }
 this->L=L1;
 return L1;
}

TVertex* TPolyline::FindVertex(double xx, double yy, double r)
{
  TVertex * v = firstV;
  double dist;
  while( v )
  {
    dist = LineLen(v->x,v->y,xx,yy);
    if( dist<r )
     return v;
    v = v->next;
  }
  return 0;
};



void TPolyline::Reverse()
{
  TVertex *p = firstV;
  TVertex *d=0, *p_end, *d0;

  while (p && p->next) p = p->next; p_end = p;
  while (p)
   {
    if( !d )
    {
      d = new TVertex;
      d0=d;
    } else
    {
     d->next = new TVertex;
     d->next->prev = d;
     d = d->next;
    }

    if( p->prev )
    {
     *d = *(p->prev);
     d->x = p->x;
     d->y = p->y;
     d->bulge = -d->bulge;
     p = p->prev;
    } else
    {
     *d = *p_end;
     d->bulge = -d->bulge;
     d->x = p->x;
     d->y = p->y;
     break;
    }
   }

  d=d0;
  while ( d->next )
  {
       CalcBulge(d,d->next);
       d = d->next;
  }

  p = firstV;
  while (p)
    {
       TVertex * tmp = p;
       p = p->next;
       delete tmp;
    }
  firstV=d0;

  double tmp = elong1;
  elong1=elong2;
  elong2=tmp;
  int tmp1 = ismus1;
  ismus1=ismus2;
  ismus2=tmp1;
  PathRepair();
}


void TPolyline::Concat(TPolyline *_s, int to_tail)
{

 if( _s->firstV && _s->firstV->next==0 ) return;
 if( firstV && firstV->next==0 ) return;

 if(to_tail)
 {
  TVertex * src = _s->firstV;
  TVertex * d = firstV;
  while (d && d->next) d = d->next;

  while(src)
   {
     if( !((d->x==src->x)&&(d->y==src->y)) )
     {  d->next = new TVertex;
       *d->next = *src;
        d->next->prev = d;
        d = d->next;
     } else *d = *src;
      src = src->next;
   }
 }
 else
 {
  TVertex *src = _s->firstV;
  TVertex *d=0, *d0;
  while(src->next) // все кроме последней точки - она совпадает
   {
      if( !d ) { d = new TVertex; d0 = d; }
      else
      {
        d->next = new TVertex;
        d->next->prev = d;
        d = d->next;
      }
      *d = *src;
      src = src->next;
   }
  d->next = firstV;
  firstV->prev = d;
  firstV = d0;
 }
 plcontainer->delPolyline(_s);
 PathRepair();
}

void TPolyline::paint(QPainter * painter, const QStyleOptionGraphicsItem * option, QWidget*)
{
    if(!plcontainer->visible) return;

    QVector<double> dashes;
    double space = 4;
    dashes << 8 << space << 8 << space ;

    const double lod = option->levelOfDetailFromTransform(painter->worldTransform());

    double pside=2;
    if(lod>1.1)
    pside=2/(lod);

    if((this->plcontainer->preview_selected))
    {
          QPen pen(0xeeeeff);
          pen.setColor(0xffffff);
          pen.setWidthF(pside*1.4);
          pen.setStyle(Qt::SolidLine);
          painter->setPen(pen);
          painter->drawPath(*path);
          return;
    }

    if( plcontainer->GC->CAD->selectedPolyline==this )
    {


        QPen pen2(0xeeeeff);
        QBrush brush2(Qt::NoBrush);
        pen2.setWidth(0);
        QPen penV(0xffffff);
        QBrush brushV(0xaaaaff);
        QPen penSel(0x99ff99);
        QBrush brushSel(0x8888ee);
        penV.setWidth(0);
        penSel.setWidth(0);

        TVertex *v = firstV;
        while(v)
         {
           if(v==SelectedVertex)
           {
               painter->setPen(penSel);
               painter->setBrush(brushSel);
               double pside1=pside*2;
               painter->drawEllipse( QRectF(SelectedVertex->x-pside1, -SelectedVertex->y-pside1, pside1*2,pside1*2) );

           } else
           {
            if(v==onMouseV)
            {
               painter->setPen(penV);
               painter->setBrush(brushV);
               double pside1=pside*1.5;
               painter->drawRect( QRectF(onMouseV->x-pside1, -onMouseV->y-pside1, pside1*2,pside1*2) );

            } else
            {
               painter->setBrush(brush2);
               painter->setPen(pen2);
               double pside1=pside*1.3;
               QRectF r=QRectF(v->x-pside1, -v->y-pside1, pside1*2,pside1*2);
               if(v==firstV)
                 {
                  pside1=pside*1.8;
                  r=QRectF(v->x-pside1, -v->y-pside1, pside1*2,pside1*2);
                  painter->drawRect( r );
                 }
               else
                  painter->drawEllipse( r );
            }
           }
           v=v->next;
         }

        if(onMousePoint.next)
        {
            penV.setColor(0xffaa33);
            painter->setPen(penV);
            painter->setBrush(brush2);
            double pside1=pside*1.5;
            painter->drawEllipse( QRectF(onMousePoint.x-pside1, -onMousePoint.y-pside1, pside1*2,pside1*2) );
        }

        QPen pen(0xff8888);
        painter->setBrush(brush2);
        pen.setWidthF(0);
        pen.setDashPattern(dashes);
        pen.setStyle(Qt::CustomDashLine);
        pen.setDashOffset(-dot_shift);
        painter->setPen(pen);

        if(path) painter->drawPath(*path);

        if(onMouseSegment)
        {
            pen.setColor(0xd0c0c0);
            pen.setWidthF(pside*1.2);
            pen.setStyle(Qt::SolidLine);
            painter->setPen(pen);
            SetVpath(onMouseSegment);
            painter->drawPath(*Vpath);

            pen.setColor(0xff1111);
            pen.setWidthF(0);
            pen.setDashPattern(dashes);
            pen.setStyle(Qt::CustomDashLine);
            pen.setDashOffset(-dot_shift);
            painter->setPen(pen);
            painter->drawPath(*Vpath);
        }

        if( SelectedSegment)
        {
            pen.setColor(0xffffff);
            pen.setWidthF(pside*1.4);
            pen.setStyle(Qt::SolidLine);
            painter->setPen(pen);
            SetVpath(SelectedSegment);
            painter->drawPath(*Vpath);

            pen.setColor(0xff1111);
            pen.setWidthF(0);
            pen.setDashPattern(dashes);
            pen.setStyle(Qt::CustomDashLine);
            pen.setDashOffset(-dot_shift);
            painter->setPen(pen);
            painter->drawPath(*Vpath);
        }

    } // if selected polyline----
    else
    {

    if( (plcontainer->GC->CAD->hoverPolyline ==this) || (plcontainer->preview_hover) )
     {
        QPen pen(0xeeeeee);
        pen.setWidthF(2/lod);
        painter->setPen(pen);
     }
     else
     if(is_copy)
     {
         QPen pen(0xffff00);
         pen.setWidthF(2/lod);
         painter->setPen(pen);
     }
     else
     {
        QPen pen(0xcccccc);

        int col = this->color;
        int base = col/10;
//        int bright=col-base*10;
        switch (col)
        {
        case 1: pen.setColor(0xff0000); break;
        case 2: pen.setColor(0xffff00); break;
        case 3: pen.setColor(0x00ff00); break;
        case 4: pen.setColor(0x00ffff); break;
        case 5: pen.setColor(0x0000ff); break;
        case 6: pen.setColor(0xff00ff); break;
        case 7: pen.setColor(0xffffff); break;
        case 8: pen.setColor(0xcccccc); break;
        case 9: pen.setColor(0xaaaaaa); break;
        case 250: pen.setColor(0x555555); break;
        case 251: pen.setColor(0x777777); break;
        case 252: pen.setColor(0x999999); break;
        case 253: pen.setColor(0xaaaaaa); break;
        case 254: pen.setColor(0xcccccc); break;
        case 255: pen.setColor(0xffffff); break;
        default:
            if(base==1) pen.setColor(0xff0000);
            if(base==2) pen.setColor(0xff5500);
            if(base==3) pen.setColor(0xff8800);
            if(base==4) pen.setColor(0xffaa00);
            if(base==5) pen.setColor(0xffff00);
            if(base==6) pen.setColor(0x55ff00);
            if(base==7) pen.setColor(0x88ff00);
            if(base==8) pen.setColor(0xaaff00);
            if(base==9) pen.setColor(0x00ff00);
            if(base==10) pen.setColor(0x00ff55);
            if(base==11) pen.setColor(0x00ff88);
            if(base==12) pen.setColor(0x00ffaa);
            if(base==13) pen.setColor(0x00ffff);
            if(base==14) pen.setColor(0x0055ff);
            if(base==15) pen.setColor(0x0088ff);
            if(base==16) pen.setColor(0x00aaff);
            if(base==17) pen.setColor(0x0000ff);
            if(base==18) pen.setColor(0x5500ff);
            if(base==19) pen.setColor(0x8800ff);
            if(base==20) pen.setColor(0xaa00ff);
            if(base==21) pen.setColor(0xff00ff);
            if(base==22) pen.setColor(0xff00aa);
            if(base==23) pen.setColor(0xff0088);
            if(base==24) pen.setColor(0xff0055);
            break;
        }

//        if(this->isSelected())
//          pen.setWidthF(3);
//        else
        pen.setWidthF(0);
        painter->setPen(pen);
     }

     if(tryConcatError)
     {
         QPen pen(0xff4444);
         pen.setWidthF(2/lod);
         painter->setPen(pen);
     }
    //  if(path)
        painter->drawPath(*path);
    }
}


void TPolyline::onMouseNearestVertex(double xx, double yy, double r)
{
    TVertex * v = TouchSegment(xx,yy,r);
    if(v==0)
    {
        onMousePoint.next=0;
        return;
    }
    double x,y;

    if(v->bulge==0)
     {
      double a;
  //    double l = sqrt((v->next->x - v->x)*(v->next->x - v->x)+ (v->next->y - v->y)*(v->next->y - v->y));
      double l1 = sqrt((xx - v->x)*(xx - v->x)+ (yy - v->y)*(yy - v->y));
      a = VectorToRadial(v->x,v->y, v->next->x,v->next->y);
      a = VectorToRadial(v->x,v->y, v->next->x,v->next->y);
      x = v->x+l1*cos(a);
      y = v->y+l1*sin(a);
     }
     else
     {
      double a = VectorToRadial(v->x0,v->y0,xx,yy);
      x = v->x0 + v->r*cos( a ) ;
      y = v->y0 + v->r*sin( a ) ;
     }
    onMousePoint.bulge = v->bulge;
    onMousePoint.x=x;
    onMousePoint.y=y;
    onMousePoint.next=&onMousePoint;
}

void TPolyline::setSelected(bool selected)
{
  SelectedSegment=0;
  onMouseV=0;
  SelectedVertex=0;
  onMouseSegment=0;

  if(this->plcontainer->GC->CAD->is_preview)
      plcontainer->GC->CAD->SelectPreviewLay(plcontainer);
  else
  {
      if(plcontainer->GC->CAD->selectedPolyline && (plcontainer->GC->CAD->selectedPolyline!= this ) )
          plcontainer->GC->CAD->selectedPolyline->setSelected(0);
      plcontainer->GC->CAD->selectedPolyline = this;
  }
  setZValue(selected?100:10);
  QGraphicsItem::setSelected(selected);

  if(plcontainer->GC->CAD->ListTool)
  {
      plcontainer->GC->CAD->ListTool->SelectPolyline(this);
      TCAD::MainWin->SetToolsVisibility(this);
  }

  this->make_cnt=1;//cnt;
}

int TPolyline::isCircle()
{
    if(type==1) return 1;
    TVertex *v = firstV;
    if(!v) return 0;
    if(v->next && v->next->next && !v->next->next->next && (v->x == v->next->next->x) && (v->y == v->next->next->y) && (v->bulge!=0) && (v->next->bulge!=0) )
        return 1;
    return 0;
}

int TPolyline::isPolygon()
{
    if(type==1) return 0;
    TVertex *v = firstV;
    if(!v) return 0;

    TVertex *v1 = lastV();

    double dx = ABS(v->x-v1->x);
    double dy = ABS(v->y-v1->y);

    if((dx<0.1) && (dy<0.1)) return 1;
    return 0;
}

void TPolyline::cmdCI()
{
    if(isCircle())
    {
        double l = firstV->r;
        if(l>10) l=10;
        TVertex *v = new TVertex(firstV->x-l, firstV->y,0);

        v->next = firstV;
        firstV->prev = v;
        firstV = v;
        PathRepair();
        TCAD::MainWin->SetToolsVisibility(this);
    }

    if(isPolygon())
    {
        TVertex *v1 = firstV;
        TVertex *v2 = lastV();

        TVertex c1,c2;

/*        c1 = v1->halfline();
        c2 = v2->prev->halfline();

        double a1 = VectorToRadial(v1->x,v1->y, c1.x,c1.y);
        double l = LineLen(v1->x,v1->y, c1.x,c1.y);

        double _x = c2.x + l*cos(a1);
        double _y = c2.y + l*sin(a1);
*/
        double _x,_y;
        int i=0;
        c1.x = c1.y = 0;
        TVertex *vv=firstV;
        while(vv)
        {
          c1.x += vv->x;
          c1.y += vv->y;
          i++;
          vv = vv->next;
        }
        _x=c1.x/i;
        _y=c1.y/i;


        if( LineLen(v1->x, v1->y, _x, _y) >10 )
        {
          double a2 = VectorToRadial(v1->x, v1->y, _x, _y);
          _x = v1->x + 10*cos(a2);
          _y = v1->y + 10*sin(a2);
        }

        TVertex *v = new TVertex(_x,_y,0);

        v->next = firstV;
        firstV->prev = v;
        firstV = v;


        PathRepair();
        TCAD::MainWin->SetToolsVisibility(this);
    }

}

void TPolyline::cmdCCI()
{
    TPolyline *p = TCAD::CAD->OrdersList.first()->FirstP();
    while(p)
    {
        if(p->isCircle()) p->cmdCI();
        p = TCAD::CAD->OrdersList.first()->NextP();
    }
    TCAD::MainWin->SetToolsVisibility( TCAD::CAD->selectedPolyline );
}

double TPolyline::VectorAngle(int is_last)
{
    double ret;

    if(!is_last)
        ret = VectorToRadial( firstV->x, firstV->y, firstV->next->x, firstV->next->y);
    else
        ret = VectorToRadial( lastV()->prev->x, lastV()->prev->y, lastV()->x, lastV()->y);

    return ret;
}


void TPolyline::hoverMoveEvent_nested(QPointF m)
{
    onMouseV = FindVertex(m.x(),-m.y(),plcontainer->GC->CAD->acc);
    if(onMouseV) onMousePoint.next=0;

    if( (plcontainer->GC->CAD->selectedPolyline==this) && !onMouseV)
    {
      onMouseSegment = TouchSegment(m.x(),-m.y(),plcontainer->GC->CAD->acc);
    }
}

void TPolyline::hoverMoveEvent(QGraphicsSceneHoverEvent * event)
{
  QPointF m = mapToScene(event->pos());
  hoverMoveEvent_nested(m);

  if( (plcontainer->GC->CAD->selectedPolyline==this) && !onMouseV)
  {
    if(event->modifiers()== Qt::ControlModifier)
        onMouseNearestVertex(m.x(),-m.y(),plcontainer->GC->CAD->acc);
    else
        onMousePoint.next=0;
  }

  QGraphicsItem::hoverMoveEvent(event);
}

void TPolyline::hoverLeaveEvent ( QGraphicsSceneHoverEvent * event)
{
    onMouseV=0;
    onMousePoint.next=0;
    onMouseSegment=0;
    QGraphicsItem::hoverLeaveEvent( event );
}

void TPolyline::mousePressEvent(QGraphicsSceneMouseEvent *)
{
//Закрыто!
}

double TPolyline::LengthofNewVertex()
{
  if(onMousePoint.next==0) return 0;
  if(onMouseSegment==0) return 0;

  if(onMouseSegment->bulge==0)
       return LineLen(onMousePoint.x,onMousePoint.y,onMouseSegment->x, onMouseSegment->y);
  else
   {
       double l,a;
       double a1 = VectorToRadial(onMouseSegment->x0, onMouseSegment->y0,onMouseSegment->x,onMouseSegment->y);;
       double a2 = VectorToRadial(onMouseSegment->x0, onMouseSegment->y0,onMousePoint.x,onMousePoint.y);

        if(onMouseSegment->bulge<0)
        {
            if(a2>a1)
                a = ABS(a2-2*M_PI-a1);
            else
                a = ABS(a2-a1);
        }
        else
        {
            if(a2<a1)
                a = ABS(a2+2*M_PI-a1);
            else
                a = ABS(a2-a1);
        }

        l = onMouseSegment->r * a;

       return l;
   }
}

void TPolyline::InsertVertex(TVertex *start, TVertex *v)
{
    TVertex *nxt = start->next;
    TVertex *nv=new TVertex(v->x,v->y,start->bulge);
    nv->prev=start;
    nv->next=nxt;
    start->next=nv;
    nxt->prev = nv;

    if(start->bulge!=0)
    {
     double a = VectorToRadial(start->x0,start->y0, v->x,v->y);
     double a1 = start->a1;
     double a2 = start->a2;

     if(start->bulge>0)
     {
      start->bulge = CalcBulgeAbs(a1,a);
      nv->bulge = CalcBulgeAbs(a,a2);
     } else
     {
      nv->bulge = - CalcBulgeAbs(a1,a);
      start->bulge = - CalcBulgeAbs(a,a2);
     }
     CalcBulge(start,nv);
     CalcBulge(nv,nxt);
    }
    PathRepair();
}

int TPolyline::ApplyNewVertex(TVertex *v, double len)
{
  if(len>v->len) return 0;
  if(len<0) return 0;

  double a,x,y;
  if(v->bulge==0)
  {
    a = VectorToRadial( v->x,v->y, v->next->x, v->next->y );
    x=v->x + len*cos(a);
    y=v->y + len*sin(a);
  } else
  {
    double a1 = VectorToRadial( v->x0,v->y0, v->x, v->y );

    if(v->bulge<0)
        a = a1 - len/(v->r);
    else
        a = a1 + len/(v->r);

    x=v->x0+cos(a)*v->r;
    y=v->y0+sin(a)*v->r;
  }

  onMousePoint.x=x;
  onMousePoint.y=y;
   InsertVertex(v,&onMousePoint);
   onMousePoint.next=0;
   TCAD::CAD->Split(this,v->next);
   setSelected(true);
   TCAD::CAD->newpointedit->setVisible(false);
  return 1;
}


int TPolyline::MovePlUp()
{
    TPolyline *p = this->prev;
    if(!p) return 0;
    if(p->prev) p->prev->next=this;

    prev->next=next;
    if(next) next->prev=p;
    this->next = p;
    this->prev=0;
    if(p)
     {
        this->prev = p->prev;

        p->prev=this;
        if(!this->prev) plcontainer->Polylines = this;
     }
    return 1;
}

int TPolyline::MovePlDown()
{
    TPolyline* p = this->next;
    if(!p) return 0;
    if(p->next) p->next->prev=this;
    next->prev=prev;
    if(prev) prev->next=p;
     else plcontainer->Polylines = p;
    this->prev = p;
    this->next=0;
    if(p)
     {
        this->next = p->next;

        p->next=this;
     }
   return 1;
}

int TPolyline::MovePlUpUp()
{
    TPolyline* p = plcontainer->Polylines;
    if(p==this) return 0;

    prev->next=next;
    if(next) next->prev=prev;

    p->prev = this;
    this->next = p;
    this->prev=0;

    plcontainer->Polylines = this;

    return 1;
}

int TPolyline::MovePlDownDown()
{
    TPolyline * p = this;

    if(plcontainer->Polylines==this) plcontainer->Polylines=this->next;
    while(p->next) p=p->next;
    if(p==this) return 0;

    next->prev=prev;
    if(prev) prev->next=next;

    p->next=this;
    this->prev = p;
    this->next=0;

   return 1;
}

void TPolyline::CalcMinMax()
{
    TVertex *v = firstV;
    if(!v) return;
    x_min=x_max=v->x;
    y_min=y_max=v->y;

    v=v->next;
    if(!v) return;
    while(v)
    {
        if(v->x>x_max) x_max=v->x;
        if(v->x<x_min) x_min=v->x;
        if(v->y>y_max) y_max=v->y;
        if(v->y<y_min) y_min=v->y;
        v=v->next;
    }
}

void TPolyline::SetLayerColor(QString _color)
{
    plcontainer->color = _color;
}
