#ifndef TPOLYLINECONTAINER_H
#define TPOLYLINECONTAINER_H

#include<tpolyline.h>
#include<qstring.h>

class TGraphScene;
class TGraphContainer;

double LineLen(double x, double y, double x1, double y1);

class TPolylineContainer
{
public:
    TPolyline* Polylines;
    QString layer;
    QString color;
    int visible;
    int selectable;
    int preview_hover;
    int preview_selected;
    int Type;
    QString idorder;
    TGraphContainer* GC;
    QRectF outer; // left bottom, right top corners

    TPolylineContainer *next;
    TPolylineContainer *prev;

    TPolyline *AddPolyline(TPolyline* _pl);
    TPolyline *NewPolyline();
    TPolylineContainer(QString _layer, QString _color, TGraphContainer*);
    ~TPolylineContainer();
    void delPolyline(TPolyline*);
    TPolyline * FindPolyline(qreal x, qreal y, qreal r);
    void CreateOffsetLines(TPolyline* p);
    void CreateOffsetLinesLeft(TPolyline* p);
    void CreateOffsetLinesRight(TPolyline* p);
    void Rotate(int steps);
    void Move(double _x, double _y);
    QPointF CalcZeroOffset();
    void CalcOutsize();
    double CalcSquare();



    TPolyline *FindNearestVertex(TPolyline* firstP, double x, double y, TPolyline *PartCont, TPolyline *curr_p);
    double distForInline( double x, double y, TPolyline* firstP, TPolyline *curr_p, int is_last);
    void MoveP(TPolyline *src, TPolyline* dest);
    void MergePolylines();

    void ToScene(QGraphicsScene *_scene);
    int MoveLayerUp();
    int MoveLayerDown();
    int MoveLayerUpUp();
    int MoveLayerDownDown();

    double CalcLenLay();
    int CalcCntLay();


    TPolyline* FindPolylineByNoInLayer(int No);
};

#endif // TPOLYLINECONTAINER_H
